#!/bin/bash

mkdir -p $HOME/.macports_lrepo/science/tlk

cat > $HOME/.macports_lrepo/science/tlk/Portfile << EOF
# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
# \$Id\$

PortSystem          1.0

name                tlk
version             1.3.1
categories          science
platforms           darwin
license             Apache2
maintainers         jvalor
description         transLectures UPV toolkit for Speech Recognition
long_description    \\
    The transLectures-UPV toolkit (TLK) is an open source (Apache \\
    License 2.0) set of tools for Automatic Speech Recognition (ASR) \\
    developed at the Universitat Politècnica de València (UPV) by \\
    the transLectures-UPV Team. The research leading to this toolkit \\
    has received funding under the European Union Seventh Framework \\
    Programme (FP7/2007-2013) under grant agreement nº 287755.
homepage            http://www.translectures.eu/tlk/

master_sites        https://launchpad.net/tlk/trunk/1.3.1/+download/
checksums           rmd160  b4ad8c724ddaa9e9ad191edead06d2602b273bc2 \\
                    sha256  98af04f1def1e4588d753bd5196b8bee46caa36349d37924dbbb12d8ddbda6ea
depends_lib         port:perl5 \\
                    port:atlas \\
                    port:sox \\
                    port:intltool \\
                    port:python27 \\
                    port:python32 \\
                    port:gawk \\
                    port:pkgconfig \\
                    port:ffmpeg \\
                    port:autoconf \\
                    port:automake \\
                    port:coreutils \\
                    port:bash \\
                    port:zlib
EOF

cd $HOME/.macports_lrepo/
portindex
chown macports:macports $HOME/.macports_lrepo
chown -R macports:macports $HOME/.macports_lrepo

cp /opt/local/etc/macports/sources.conf /opt/local/etc/macports/sources.conf.bak
cat /opt/local/etc/macports/sources.conf.bak | grep "^#" > /opt/local/etc/macports/sources.conf
echo "file://$HOME/.macports_lrepo" >> /opt/local/etc/macports/sources.conf
echo "rsync://rsync.macports.org/release/tarballs/ports.tar [default]" >> /opt/local/etc/macports/sources.conf

port selfupdate

echo -en "Done.\n\n\n\n\n"
echo -en "You can install TLK with:\n"
echo -en "\tsudo port install tlk\n\n"

