#!/bin/bash

#
#  Copyright 2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

# -- XUQUER --
# Transcriptor fonètic per a català, variant occidental.
# Ideat per a sistemes ASR en català.
# Desenvolupat pel transLectures-UPV team.
# València, Juliol 2013.

# Fonemes: abdefgGiklLmnNoprRstuxz

gawk '{print tolower($0)}' < /dev/stdin | 
sed -e "s/[-!?.,;:\"'%\&()\/=+\\{}<>*]/ /g" \
    -e "s/º/ /g" -e "s/ª/ /g" -e "s/¡/ /g" -e "s/¿/ /g" \
    -e 's|\[| |g' -e 's|\]| |g' \
    -e 's|á|a|g' -e 's|é|e|g' -e 's|í|i|g' \
    -e 's|ó|o|g' -e 's|ú|u|g' -e 's|à|a|g' \
    -e 's|è|e|g' -e 's|ì|i|g' -e 's|ò|o|g' \
    -e 's|ù|u|g' -e 's|ä|a|g' -e 's|ë|e|g' \
    -e 's|ï|i|g' -e 's|ö|o|g' -e 's|â|a|g' \
    -e 's|ê|e|g' -e 's|î|i|g' -e 's|ô|o|g' \
    -e 's|û|u|g' \
       -e 's|ch|X|g' \
       -e 's|h||g' \
       -e 's|rr| R|g' \
       -e 's|^r| R|g' \
       -e 's| r| R|g' \
       -e 's|ny| N|g' \
       -e 's|ñ| N|g' \
       -e 's|ll| L|g' \
       -e 's|l·l| l|g' \
       -e 's|l| l|g' \
       -e 's|jj|j|g' \
       -e 's|j| G|g' \
       -e 's|gg|g|g' \
       -e 's|g\([ei]\)| G\1|g' \
       -e 's|ss| s|g' \
       -e 's|^s| s|g' \
       -e 's| s| s|g' \
       -e 's|\([aeiou]\)s\([aeiou]\)| \1 z \2|g' \
       -e 's|s| s|g' \
       -e 's|cc\([ei]\)| k s \1|g' \
       -e 's|cc\([aou]\)| k \1|g' \
       -e 's|c\([ei]\)| s\1|g' \
       -e 's|ç| s|g' \
       -e 's|zz| t z|g' \
       -e 's|z| z|g' \
       -e 's|c\([aou]\)| k\1|g' \
       -e 's|ck| k|g' \
       -e 's|c| k|g' \
       -e 's|qu\([ei]\)| k\1|g' \
       -e 's|qü\([ei]\)| k u\1|g' \
       -e 's|q| k|g' \
       -e 's|gu\([ei]\)| g\1|g' \
       -e 's|gü\([ei]\)| g u\1|g' \
       -e 's|g\([aou]\)| g\1|g' \
       -e 's|ü|u|g' \
       -e 's| x| x|g' \
       -e 's|^x| x|g' \
       -e 's|tx| x|g' \
       -e 's|ig | i G|g' \
       -e 's|ig$| i G|g' \
       -e 's|ix| i s|g' \
       -e 's|y| i|g' \
       -e 's|w| u|g' \
       -e 's|v| b|g' \
       -e 's|X| x|g' \
       -e 's|aa|a|g' \
       -e 's|ee|e|g' \
       -e 's|ii|i|g' \
       -e 's|oo|o|g' \
       -e 's|uu|u|g' \
       -e 's|dd|d|g' \
       -e 's|pp|p|g' \
       -e 's|tt|t|g' \
       -e 's|nn|n|g' \
       -e 's|cc|c|g' \
       -e 's|mm|m|g' \
       -e 's|ff|f|g' \
       -e 's|bb|b|g' \
       -e 's|vv|v|g' \
       -e 's|kk|k|g' \
       -e 's|\([^ ]\)| \1 |g' \
       -e "s|[^abdefgGiklLmnNoprRstuxz ]||g" \
       -e 's/[ \t]\+/ /g' \

