#!/usr/bin/perl -CSio

#
#  Copyright 2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

# Convert complex UTF8 characters to the nearest ASCII character.
#
# Don't try to re-code, just use this script!
#########################################################################
#  Isaias Sanchez -Cortina, 2013
#
#   UTF8_toBestMatching_ASCII.perl is free software: you can redistribute it
#  and/or modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation, either version 3 of
#  the License, or (at your option) any later version.
#
#  You should have received a copy of the GNU General Public License
#  along with transLectures-UPV-tools. If not, see
#  <http://www.gnu.org/licenses/>.


use Unicode::Normalize;

# 
# while ( <STDIN> ) {  # the variable we work on
#    ##  convert to Unicode first
#    ##  if your data comes in Latin-1, then uncomment:
#    #$_ = Encode::decode( 'iso-8859-1', $_ );  
#    $_ = NFD( $_ );   ##  decompose
#    s/\pM//g;         ##  strip combining characters
#    s/[^\0-\x80]//g;  ##  clear everything else
#    
#    print 
#  }
# while (<>) {  # the variable we work on
# 
#    ##  convert to Unicode first
#    ##  if your data comes in Latin-1, then uncomment:
#    #$_ = Encode::decode( 'iso-8859-1', $_ );  
# 
#    s/\xe4/ae/g;  ##  treat characters ä ñ ö ü ÿ
#    s/\xf1/ny/g;  ##  this was wrong in previous version of this doc    
#    s/\xf6/oe/g;
#    s/\xfc/ue/g;
#    s/\xff/yu/g;
# 
#    $_ = NFD( $_ );   ##  decompose (Unicode Normalization Form D)
#    s/\pM//g;         ##  strip combining characters
# 
#    # additional normalizations:
# 
#    s/\x{00df}/ss/g;  ##  German beta “ß” -> “ss”
#    s/\x{00c6}/AE/g;  ##  Æ
#    s/\x{00e6}/ae/g;  ##  æ
#    s/\x{0132}/IJ/g;  ##  Ĳ
#    s/\x{0133}/ij/g;  ##  ĳ
#    s/\x{0152}/Oe/g;  ##  Œ
#    s/\x{0153}/oe/g;  ##  œ
# 
#    tr/\x{00d0}\x{0110}\x{00f0}\x{0111}\x{0126}\x{0127}/DDddHh/; # ÐĐðđĦħ
#    tr/\x{0131}\x{0138}\x{013f}\x{0141}\x{0140}\x{0142}/ikLLll/; # ıĸĿŁŀł
#    tr/\x{014a}\x{0149}\x{014b}\x{00d8}\x{00f8}\x{017f}/NnnOos/; # ŊŉŋØøſ
#    tr/\x{00de}\x{0166}\x{00fe}\x{0167}/TTtt/;                   # ÞŦþŧ
# 
#    s/[^\0-\x80]//g;  ##  clear everything else; optional
#    print
#  }

if ( -t STDIN ) {
use utf8;
print STDERR "
 example :
  echo    ł   ŧ   ŋ   ß    ð    Ẑ    ä    Ñ     æ    | $0 
 returns :
          l   t   n   ss   d    Z    a    N     ae
  
# Convert complex UTF8 characters to the best matching ASCII sequence of characters.
#
# It should be noted that despite the script is very simple and
#  it relies on standard UTF8 normalization routines  (NFC, NFKC, NFD and NFKD.)
#  it was not easy at all to come up with the proper use to make them work.
#
# Any other solutions found in the web were just not complete. 
# ie., they work only with tildes, or umlauts at most. 
# 
#
# So, please, don't try to re-code, just use this script
#  or modify it for further refinement!
";
exit(1);
}

while (<>) {


    s/\x{00df}/ss/g;  ##  German beta “ß” -> “ss”
    s/\x{00c6}/AE/g;  ##  Æ
    s/\x{00e6}/ae/g;  ##  æ
    s/\x{0132}/IJ/g;  ##  Ĳ
    s/\x{0133}/ij/g;  ##  ĳ
    s/\x{0152}/Oe/g;  ##  Œ
    s/\x{0153}/oe/g;  ##  œ
 
    tr/\x{00d0}\x{0110}\x{00f0}\x{0111}\x{0126}\x{0127}/DDddHh/; # ÐĐðđĦħ
    tr/\x{0131}\x{0138}\x{013f}\x{0141}\x{0140}\x{0142}/ikLLll/; # ıĸĿŁŀł
    tr/\x{014a}\x{0149}\x{014b}\x{00d8}\x{00f8}\x{017f}/NnnOos/; # ŊŉŋØøſ
    tr/\x{00de}\x{0166}\x{00fe}\x{0167}/TTtt/;                   # ÞŦþŧ
#    s/[^\0-\x80]//g;  ##  clear everything else; optional
   for (split(//)) {
      $_=substr(NFD($_),0,1) ; 
      s/[^\0-\x80]//g; 
      print
   }
}
