#!/usr/bin/perl -w 

#
#  Copyright 2012,2013,2014 transLectures-UPV Team
#  Copyright 2011 Isaías Sánchez Cortina
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

# Extract all text from a  tr subtitles file format
#         v0.1 July 2013 , by  isanchez@dsic.upv.es
# Modified from convert-srt_to_ak , v0.1 Feb 2011 by isanchez@dsic.upv.es


use strict;

my $NewLine="\n";

while (@ARGV){
    $_= shift;
    # Operation modes:
    /^-h$/ && (help(), exit); # HELP
    /^-n$/ && ($NewLine="\n",next); # HELP
}


# Precompile  regex
my $rTag=qr/<([^<>]*)>/;

# Main loop : for each line in a srt-formated  file:
my $text="";
my $rTimeBegin=qr/time\s+begin\s*=\s*\"((?'hh'\d+):)?(?'mm'\d+):(?'ss'\d+(\.\d+)?)\"/i;
my $rNext=qr/^\s*$/;
while(<STDIN>){
    next if $_ =~ $rNext;
    if (($_=~$rTag) && ($_ =~ $rTimeBegin) ){
        $text.=$NewLine;
     }
     chomp; 
    s/$rTag/ /g;
    s/\s+/ /;
    $text.=$_;
}

print $text; 


sub help{
print STDERR "
\e[47;30m".( "-" x 80)."
".( "-" x 80)."\e[0m 
TODO
\e[1mSYNTAX\e[0m
    cat FILE_STDIN | $0  [Options] > OUTPUT_HUGEPHRASE_TXT 
Help:
-h                : Show this help.

Audio file to be segmented:


Paths:

Optional:

#         v0.1 July 2013 , by  isanchez\@dsic.upv.es
# Modified from convert-srt_to_ak , v0.1 Feb 2011 by isanchez\@dsic.upv.es


";
}
