#!/usr/bin/perl -w

#
#  Copyright 2012,2013,2014 transLectures-UPV Team
#  Copyright 2011 Isaías Sánchez Cortina
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

# Segment srt subtitle files for further ASR processing.

# Modified from convert-srt_to_ak , v0.1 Feb 2011 by isanchez@dsic.upv.es
# Initial version                 , v0.1 1 July 2013 , by  isanchez@dsic.upv.es
# Fixed Bugs:                     , v0.11 15 July 2013 by isanchez@dsic.upv.es

use strict ;


my $Newline="\n";
my $skipBlanks=1; # to be implemented 

while (@ARGV){
    $_= shift;
    # Operation modes:
    /^-h$/ && (help(), exit); # HELP
    # Paths:
    /^-n$/ && ($Newline=' ', next);
    /^-s$/ && ($skipBlanks=0, next);
}


# Precompile  regex
# my $REGEX_time=qr/((?'hh1'\d++):)?((?'mm1'\d++):)(?'ss1'\d++)(,(?'ms1'\d++))?[^\d]*-->[^\d]*((?'hh2'\d+):)?((?'mm2'\d+):)(?'ss2'\d+)(,(?'ms2'\d+))?/;
my $REGEX_time=qr/\d+:.*-->.*\d+:/;
my $REGEX_next=qr/^\s*$/;
my $REGEX_digit=qr/^\d+\s*$/;

# Helper vars
my $bInTurn=0;

# Main loop : for each line in a srt-formated  file:
while(<STDIN>){
    if (($_ =~ $REGEX_next) || ($_=~$REGEX_time) || ($_=~$REGEX_digit)  ) {
        print "$Newline" if $bInTurn;
        $bInTurn=0;
        next;
    }
    $bInTurn=1;
    chomp ;
    print "$_ " ;
}





#############



sub help{
print STDERR "
\e[1m$0:\e[0m
\e[47;30m".( "-" x 80)."
".( "-" x 80)."\e[0m 
\e[1mSYNTAX\e[0m
    cat FILE_SRT | $0  [Options] > OUTPUT_HUGEPHRASE_TXT 

-n                : Print all text in a single line (useful for realignment);
-h                : Show this help.




#         v0.1 July 2013 , by  isanchez\@dsic.upv.es
# Modified from convert-srt_to_ak , v0.1 Feb 2011 by isanchez\@dsic.upv.es


";
}
