#!/bin/bash

#
#  Copyright 2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

Dictionary=$1
targetPath=$2
name=$3
G2P_BASEPATH=${G2P_BASEPATH:-$4}

[ -z "$targetPath" ] && targetPath=`dirname "$Dictionary" ` 
[ -z "$name" ] && name=`basename "$Dictionary"`
[ -z "$G2P_BASEPATH" ]  && G2P_BASEPATH=`dirname $0`/external/g2p

G2P=${G2P:-$G2P_BASEPATH/bin/g2p.py}
export PYTHONPATH="$G2P_BASEPATH/lib/python2.7/site-packages/"


set -eu

mkdir -p ${targetPath} || exit 1

initfromm=1
for ((m=$initfromm; m<=9 ; m++)) ; do
    if [ -s "$targetPath/$name-$m.g2p-model" ] ; then
        initfromm=$((m+1))
    else
        break
    fi
done
echo "g2p training: [II] Training grapheme to phoneme model using dictionary $Dictionary . Iteration $initfromm" >&2

for (( m=$initfromm ; m<=9 ; m++ )) ; do
    continue="--model   $targetPath/$name-$((m-1)).g2p-model --ramp-up "
    [ "$m" -eq 1 ] && continue="" 
    echo "$targetPath/$name-$m.g2p-model"
    "$G2P" $continue -C --size-constraint 0,1,0,1  --encoding UTF-8   \
         --train "$Dictionary"  --devel 2%  --write-model "$targetPath/$name-$m.g2p-model"
done


