#!/bin/bash

#
#  Copyright 2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

READLINK=`which greadlink`; READLINK=${READLINK:-readlink}; READLINK="$READLINK -f"

set -e

BPATH=`$READLINK $0`
export BPATH=`dirname $BPATH`

function call_parse_tr {

    $BPATH/parse_tr.sh pho -sub am -translit -sp < $1 > $2
    
}

if [[ $# != 3 ]]
then
    echo "$0 <FEALIST> <DIR_IN> <DIR_OUT>" >&2
    exit 1
fi
FEAS=$1
IDIR=$2
ODIR=$3

while read sample
do
    NAME=${sample%%.tLfea}
    call_parse_tr $IDIR/$NAME.tr $ODIR/$NAME.pho
    echo $NAME.pho
done < $FEAS
