#!/bin/bash 
#
#  Copyright 2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

. `dirname $0`/mhrecognise_prolog.sh

function print_help {
  echo $"$0 [options] <input_model> <output_model>

  <input_model>         Acoustic input model
  <output_model>        Acoustic output hybrid model

Options:

  -h:                   Print this help
  -b <path>             tLbin2txt PATH"
}

NUMARGS=2
TLBIN2TXT=tLbin2txt
while getopts "hb:" OPT
do
    case $OPT in
        h) print_help; exit 0;;
        b) TLBIN2TXT=$OPTARG;;
    esac
done
[ $[$#-OPTIND+1] -ge $NUMARGS ] || { print_help >&2; echo $[$#-OPTIND+1] $NUMARGS; exit 1; }
shift $[OPTIND-1]
INPUT=$1
OUTPUT=$2
shift 2

mkdir -p `dirname $OUTPUT`
$TLBIN2TXT amodel -i $INPUT | tied2hyb.py > $OUTPUT

