#!/bin/bash 
#
#  Copyright 2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

. `dirname $0`/mhrecognise_prolog.sh

function print_help {
  echo $"$0 [options] <tmpdir> <dnn_network>

  <input_lst>                 Input sample list
  <dnn_network>               Number of splits to divide the sample list
  <tmpdir>                    Temporal directory to store temporary files for the recognition 

Options:

  -h:                         Print this help
  -c <path>:                  Path the to dnnclassify executable"
}

NUMARGS=3
DNNCLASSIFY="dnnclassify"
while getopts "hc:" OPT
do
  case $OPT in
        h) print_help; exit 0;;
        c) DNNCLASSIFY=$OPTARG;;
  esac
done
[ $[$#-OPTIND+1] -eq $NUMARGS ] || { print_help >&2; exit 1; }
shift $[OPTIND-1]

SAMPLE_LST=$1
NET=$2
TMP=$3

mkdir -p $TMP/tmp
cat $SAMPLE_LST | awk -v folder=$TMP '{print folder"/tmp/senones/"$0}' > $TMP/tmp/senones.lst.tmp
mkdir -p $(for i in `< $TMP/tmp/senones.lst.tmp`; do 
  dirname $i
done | sort -u)

COMMAND="$DNNCLASSIFY -samples $SAMPLE_LST \
                  -net $NET -batch 200 -osamples $TMP/tmp/senones.lst.tmp"

echo $COMMAND
$COMMAND

mv $TMP/tmp/senones.lst.tmp $TMP/tmp/senones.lst

