#!/bin/bash

# Copyright 2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

. mhtrain_em_prolog.sh

function print_help {
    cat <<EOF
$0 [options] <tmpdir> [ADDITIONAL OPS FOR tLalign]

  <tmpdir>        Temporal directory of the estimation

  Options:

  -h:             Print this help
  -e <path>       Path to tLalign
EOF
}

NUMARGS=1
ALIGNEX=tLalign
ADDITIONAL_COUNTS=""
while getopts "he:" OPT
do
  case $OPT in
        h) print_help; exit 0;;
        e) ALIGNEX=$OPTARG;;
  esac
done
[ $[$#-OPTIND+1] -eq $NUMARGS ] || { print_help >&2; exit 1; }
shift $[OPTIND-1]
TMP=$1
shift 1

set -e

OPTS="$@"

if [ -z $SGE_TASK_ID ]; then
  echo "[EE] External variable \$SGE_TASK_ID needed"
  exit 1
fi
i=${SGE_TASK_ID}

COMMAND="$ALIGNEX $TMP/model_0 $TMP/words_$i $TMP/feas_$i \
       -o $TMP/align_$i -v --state-align $OPTS"
echo $COMMAND
$COMMAND

