#!/bin/bash 
#
#  Copyright 2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

. `dirname $0`/mhrecognise_prolog.sh

function print_help {
  echo $"$0 [options] <tmpdir> <samples-list> <splits>

  <tmpdir>                    Temporal directory to store temporary files for the recognition 
  <samples-list>              List of samples to be recognised
  <splits>                    Number of splits to divide the <samples-list>

Options:

  -w                          Prepare the generation of word-graphs"
}

NUMARGS=3
WORDGRAPH="no"
while getopts "hw" OPT
do
  case $OPT in
        h) print_help; exit 0;;
        w) WORDGRAPH="yes";;
  esac
done
[ $[$#-OPTIND+1] -eq $NUMARGS ] || { print_help >&2; exit 1; }
shift $[OPTIND-1]

TMP=$1
SAMPLES_LST=$2
SPLITS=$3

mkdir -p $TMP/tmp

split_list.sh $SPLITS $TMP/tmp/feas $SAMPLES_LST

if [ "$WORDGRAPH" != "no" ]; then
  cat $SAMPLES_LST | awk -v folder=$TMP '{print folder"/wordgraphs/"$0}' > $TMP/tmp/wgs.lst
  for i in `< $TMP/tmp/wgs.lst`; do 
    dirname $i
  done | sort -u | xargs mkdir -p
  split_list.sh $SPLITS $TMP/tmp/wgs $TMP/tmp/wgs.lst
fi

