#!/bin/bash

# Copyright 2012,2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

set -eu

PRGNAME=${PRGNAME:-`basename "${BASH_SOURCE[1]}"`}
REALPRGNAME=`basename "$0"`

function log {
    echo -e "[II] $PRGNAME : $@" >&2 || return 0 
}
function log_ne {
    echo -ne "[II] $PRGNAME : $@\r" >&2  || return 0 
}
function success {
    echo -e "[II] $PRGNAME : OK! $@" >&2 || return 0 
}
function debug {
    echo -e "[GG] $REALPRGNAME:`caller 0` $@" >&2 || return 0 
}
function _debug {
    echo -e "[GG] $REALPRGNAME:`caller 1` $@" >&2 || return 0 
}
function warning {
    echo -e "[WW] $REALPRGNAME: $@" >&2
}
function error {
    echo -e "[EE] $PRGNAME:`caller 0` $@" >&2
    exit 1
}
function _error {
    echo -e "[EE] $REALPRGNAME:`caller 1` $@" >&2
    exit 1
}

