#!/bin/bash

# Copyright 2012,2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

set -e

function print_help {
    cat <<EOF
$0 [options] <tmpdir> <input-model> <word-list> <samples-list> <splits>

  <tmpdir>        Temporal directory of the estimation
  <input-model>   Path to store the output model (extensions will be added)
  <word-list>     List of transcription 
  <samples-list>  List of samples
  <splits>        Number of splits to divide the experiment

EOF
}

NUMARGS=5
while getopts "h" OPT
do
  case $OPT in
        h) print_help; exit 0;;
  esac
done
[ $[$#-OPTIND+1] -eq $NUMARGS ] || { print_help >&2; exit 1; }
shift $[OPTIND-1]

TMP=$1
MODEL=$2
WORDLIST=$3
PBMLIST=$4
N=$5

mkdir -p $TMP

while read l
do
    NW=`cat $l | wc -w`
    if [[ $NW -eq 0 ]]
    then
        echo "SP" > $l
    fi
done < $WORDLIST

split_list.sh $N $TMP/words $WORDLIST
split_list.sh $N $TMP/feas $PBMLIST
cp $MODEL $TMP/model_0
