#!/bin/bash

# Copyright 2012,2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

set -e

if [[ $# != 3 ]]
then
    echo "split_list.sh <N> <PREFIX> <LLISTA>" >&2
    exit 1
fi
N=$1
PREFIX=$2
LLISTA=$3

NUM=`cat $LLISTA | wc -l`
NDOCS=$[NUM/N]
NDOCS2=$[NDOCS+1]
REST=$[NUM%N]

END=1
for (( i= 1; i <= REST; ++i ))
do
    BEGIN=$END
    END=$[BEGIN+NDOCS2]
    gawk -v B=$BEGIN -v E=$END 'NR>=B && NR<E' $LLISTA > ${PREFIX}_${i}
done
for (( i= REST+1; i <= N; ++i ))
do
    BEGIN=$END
    END=$[BEGIN+NDOCS]
    gawk -v B=$BEGIN -v E=$END 'NR>=B && NR<E' $LLISTA > ${PREFIX}_${i}
done
