#!/bin/bash
#
#  Copyright 2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

gawk 'NF == 1 && /^".*"$/ { 
        name=$0; 
        filename=gensub(/"(.*)"$/,"\\1","g",name);
        time=gensub(/^(.*\/)?([0-9.]*_[0-9.]*)-.*$/,"\\2","g",name); 
        if(time !~ /_/ ) # not tLtask recognise format, maybe time first
          time=gensub(/^([0-9.]*_[0-9]*)-.*$/,"\\1","g",name); 
        start=time; 
        sub("_.*$","",start); 
        end=time; 
        sub(".*_","",end); 
        speaker="UNK"; 
        channel="1"; trans="";
        framestart=-1} 
      NF > 1 {
        if(framestart==-1) 
        { 
          framestart=$1; 
          word=$NF 
          begin= 1
        } 
        else 
        { 
          if($4==0) 
          { 
            if (!begin) printf("%s %s %f %f %s\n", filename,channel,start+framestart*0.01,dur*0.01,word); word=$NF; 
            begin= 0
            framestart=$1; dur=0;
          }
        }
        dur+= $2;
      } 
      NF == 1 && /^\.$/ { 
        if(framestart != -1)
            printf("%s %s %f %f %s\n", filename,channel,start+framestart*0.01,dur*0.01,word); 
        else
            printf("%s %s %f %f @\n", filename,channel,start,dur*0.01); 
}'
