#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright 2014 transLectures-UPV Team
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from TLK import *
import sys
from optparse import OptionParser

def w_(txt): OUT.write(txt.encode('utf-8'))
def w(txt): w_(txt+'\n')

parser= OptionParser(usage='%prog [options]')
parser.add_option('-i','--input',dest='input',
                  help=(u"input model. By default stdin."),
                  default=None,metavar='FILE')
parser.add_option('-o','--output',dest='output',
                  help=(u"output model. By default stdout."),
                  default=None,metavar='FILE')
(opts,args)= parser.parse_args()
if len(args)!=0:
    parser.error("Incorrect number of parameters")
OUT= file(opts.output,'w') if opts.output!=None else sys.stdout
m= AModel(file(opts.input) if opts.input!=None else sys.stdin)
if m.tname!='TiedStates': sys.error(u"only TiedStates models are supported")

w(u'AMODEL')
w(u'TiedStates')
w(u'Hybrid')
w(u'D %d'%m.members_args.N)
w(u'N %d'%m.members_args.N)
w(u'States')
for n in xrange(0,m.members_args.N):
    w(u'%s %d'%(m.members_args.names[n],n))
w(u'N %d'%m.N)
for n in xrange(0,m.N):
    w(u"'%s'"%m.labels[n])
    m.hmms[n].write(OUT,m)
