#!/usr/bin/env python
# -*- coding: utf-8 -*-

#
#  Copyright 2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

import sys
import os

class Seg:
    def __init__(self,b,e,w):
        self.begin= b
        self.end= e
        self.word= w
    def __repr__(self):
        return '<%d,%d,%s>'%(self.begin,self.end,self.word)

def compact_sample(sample):
    if sample == [] : return []
    ret= []
    s= sample[0]
    for s2 in sample[1:]:
        if s.word==s2.word and s.end+1==s2.begin:
            s.end= s2.end
        else:
            ret.append(s)
            s= s2
    ret.append(s)
    return ret

def read_sample(f):
    # Descarta capçalera
    l= f.readline()
    while l != '':
        line= l.strip()
        l= f.readline()
        if line != '' : break
    # Aliniaments
    aux= []
    while l != '' and l.strip()!='.':
        line= l.strip()
        l= f.readline()
        if line == '' : continue
        b,d,w= line.split()
        aux.append(Seg(int(b),int(b)+int(d)-1,w))
    return compact_sample(aux)

def read_file(fn):
    f= open(fn)
    ret= []
    s= read_sample(f)
    while s != []:
        ret.append(s)
        s= read_sample(f)
    return ret

def sample_names(pred_fn):
    pred_fd=open(pred_fn)
    sn=[]
    for l in pred_fd:
        if l[0] == '"':
            sn.append(os.path.basename(l.split('"')[1]))
    return sn

# Inici
if len(sys.argv) != 3:
    sys.exit('%s <aklign_file> <out_dir>'%sys.argv[0])
akligns= read_file(sys.argv[1])
out= sys.argv[2]
sn= sample_names(sys.argv[1])

if os.path.isdir('%s'%(out)) == False:
    os.makedirs('%s'%(out))

for v in range(len(akligns)):
    trs_fn= out+"/"+os.path.splitext(sn[v])[0]+".trs"
    trs= open(trs_fn,'w')
    header= ('<?xml version="1.0" encoding="ISO-8859-1"?>\n'+
		        '<!DOCTYPE Trans SYSTEM "trans-14.dtd">\n'+
		        '<Trans scribe="aktoolkit" audio_filename="'+os.path.splitext(sn[v])[0]+'.wav" version="2" version_date="120116">\n'+
					  '<Speakers>\n'+
					  '<Speaker id="unk" name="Unknown" check="no" type="" dialect="" accent="" scope="local"/>\n'+
					  '</Speakers>\n'+
					  '<Episode>\n'+
					  '<Section type="report" startTime="0" endTime="'+str(akligns[v][len(akligns[v])-1].end/100.0)+'">\n'+
					  '<Turn startTime="0" endTime="'+str(akligns[v][len(akligns[v])-1].end/100.0)+'" speaker="unk">\n')
    trs.write(header)
    
    for s in range(len(akligns[v])):
       sync= '<Sync time="'+str(akligns[v][s].begin/100.0)+'"/>\n'+akligns[v][s].word+'\n'
       trs.write(sync)

    end= ('</Turn>\n'+
		      '</Section>\n'+
					'</Episode>\n'+
					'</Trans>\n')
    trs.write(end)
    
    trs.close()

