#  Copyright 2012,2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

[
    ("L_Class-Stop",'(^p-)|(^b-)|(^t-)|(^d-)|(^k-)|(^g-)'),
    ("L_Nasal",'(^m-)|(^n-)|(^ng-)'),
    ("L_FricatAffricative",'(^s-)|(^sh-)|(^z-)|(^zh-)|(^f-)|(^v-)|(^ch-)|(^jh-)|(^th-)|(^dh-)'),
    ("L_Liquid",'(^l-)|(^el-)|(^r-)|(^ua-)|(^ia-)|(^w-)|(^y-)|(^hh-)'),
    ("L_Vowel",'(^ey-)|(^ea-)|(^eh-)|(^ih-)|(^ao-)|(^ae-)|(^aa-)|(^oh-)|(^uw-)|(^ua-)|(^uh-)|(^er-)|(^ay-)|(^oy-)|(^iy-)|(^ia-)|(^aw-)|(^ow-)|(^ax-)|(^ah-)'),
    ("L_C-Front",'(^p-)|(^b-)|(^m-)|(^f-)|(^v-)|(^w-)'),
    ("L_C-Central",'(^t-)|(^d-)|(^n-)|(^s-)|(^z-)|(^zh-)|(^th-)|(^dh-)|(^l-)|(^el-)|(^r-)|(^ua-)|(^ia-)'),
    ("L_C-Back",'(^sh-)|(^ch-)|(^jh-)|(^y-)|(^k-)|(^g-)|(^ng-)|(^hh-)'),
    ("L_V-Front",'(^iy-)|(^ia-)|(^ih-)|(^ey-)|(^ea-)|(^eh-)'),
    ("L_V-Central",'(^ae-)|(^oh-)|(^aa-)|(^er-)|(^ao-)'),
    ("L_V-Back",'(^uw-)|(^ua-)|(^uh-)|(^ow-)|(^ax-)|(^ah-)'),
    ("L_Front",'(^p-)|(^b-)|(^m-)|(^f-)|(^v-)|(^w-)|(^iy-)|(^ia-)|(^ih-)|(^ey-)|(^ea-)|(^eh-)'),
    ("L_Central",'(^t-)|(^d-)|(^n-)|(^s-)|(^z-)|(^zh-)|(^th-)|(^dh-)|(^l-)|(^el-)|(^r-)|(^ua-)|(^ia-)|(^ae-)|(^aa-)|(^er-)|(^ao-)'),
    ("L_Back",'(^sh-)|(^ch-)|(^jh-)|(^y-)|(^k-)|(^g-)|(^ng-)|(^hh-)|(^oh-)|(^uw-)|(^ua-)|(^uh-)|(^ow-)|(^ax-)|(^ah-)'),
    ("L_Fortis",'(^p-)|(^t-)|(^k-)|(^f-)|(^th-)|(^s-)|(^sh-)|(^ch-)'),
    ("L_Lenis",'(^b-)|(^d-)|(^g-)|(^v-)|(^dh-)|(^z-)|(^zh-)|(^jh-)'),
    ("L_UnFortLenis",'(^m-)|(^n-)|(^ng-)|(^hh-)|(^l-)|(^el-)|(^r-)|(^ua-)|(^ia-)|(^y-)|(^w-)'),
    ("L_Coronal",'(^t-)|(^d-)|(^n-)|(^th-)|(^dh-)|(^s-)|(^z-)|(^sh-)|(^zh-)|(^ch-)|(^jh-)|(^el-)|(^l-)|(^r-)|(^ua-)|(^ia-)'),
    ("L_NonCoronal",'(^p-)|(^b-)|(^m-)|(^k-)|(^g-)|(^ng-)|(^f-)|(^v-)|(^hh-)|(^y-)|(^w-)'),
    ("L_Anterior",'(^p-)|(^b-)|(^m-)|(^t-)|(^d-)|(^n-)|(^f-)|(^v-)|(^th-)|(^dh-)|(^s-)|(^z-)|(^l-)|(^el-)|(^w-)'),
    ("L_NonAnterior",'(^k-)|(^g-)|(^ng-)|(^sh-)|(^zh-)|(^hh-)|(^ch-)|(^jh-)|(^r-)|(^ua-)|(^ia-)|(^y-)'),
    ("L_Continuent",'(^m-)|(^n-)|(^ng-)|(^f-)|(^v-)|(^th-)|(^dh-)|(^s-)|(^z-)|(^sh-)|(^zh-)|(^hh-)|(^l-)|(^el-)|(^r-)|(^ua-)|(^ia-)|(^y-)|(^w-)'),
    ("L_NonContinuent",'(^p-)|(^b-)|(^t-)|(^d-)|(^k-)|(^g-)|(^ch-)|(^jh-)'),
    ("L_Strident",'(^s-)|(^z-)|(^sh-)|(^zh-)|(^ch-)|(^jh-)'),
    ("L_NonStrident",'(^f-)|(^v-)|(^th-)|(^dh-)|(^hh-)'),
    ("L_UnStrident",'(^p-)|(^b-)|(^m-)|(^t-)|(^d-)|(^n-)|(^k-)|(^g-)|(^ng-)|(^l-)|(^el-)|(^r-)|(^ua-)|(^ia-)|(^y-)|(^w-)'),
    ("L_Glide",'(^hh-)|(^l-)|(^el-)|(^r-)|(^ua-)|(^ia-)|(^y-)|(^w-)'),
    ("L_Syllabic",'(^el-)|(^er-)'),
    ("L_Unvoiced-cons",'(^p-)|(^t-)|(^k-)|(^s-)|(^sh-)|(^f-)|(^th-)|(^hh-)|(^ch-)'),
    ("L_Voiced-cons",'(^jh-)|(^b-)|(^d-)|(^dh-)|(^g-)|(^y-)|(^l-)|(^el-)|(^m-)|(^n-)|(^ng-)|(^r-)|(^ua-)|(^ia-)|(^v-)|(^w-)|(^z-)'),
    ("L_Unvoiced-all",'(^p-)|(^t-)|(^k-)|(^s-)|(^sh-)|(^f-)|(^th-)|(^hh-)|(^ch-)'),
    ("L_Long",'(^iy-)|(^ia-)|(^ow-)|(^aw-)|(^ao-)|(^uw-)|(^ua-)|(^el-)'),
    ("L_Short",'(^ae-)|(^ey-)|(^ea-)|(^aa-)|(^eh-)|(^ih-)|(^ay-)|(^oy-)|(^oh-)|(^ax-)|(^ah-)|(^uh-)'),
    ("L_Dipthong",'(^ey-)|(^ea-)|(^ay-)|(^oy-)|(^aw-)|(^er-)|(^el-)'),
    ("L_Front-Start",'(^ey-)|(^ea-)|(^aw-)|(^er-)'),
    ("L_Fronting",'(^ay-)|(^ey-)|(^ea-)|(^oy-)'),
    ("L_High",'(^ih-)|(^uw-)|(^ua-)|(^uh-)|(^iy-)|(^ia-)'),
    ("L_Medium",'(^ey-)|(^ea-)|(^er-)|(^ax-)|(^ah-)|(^ow-)|(^eh-)|(^el-)'),
    ("L_Low",'(^ae-)|(^ay-)|(^aw-)|(^aa-)|(^oh-)|(^ao-)|(^oy-)'),
    ("L_Rounded",'(^ao-)|(^uw-)|(^ua-)|(^uh-)|(^oy-)|(^ow-)|(^w-)'),
    ("L_Unrounded",'(^eh-)|(^ih-)|(^ae-)|(^aa-)|(^oh-)|(^er-)|(^ay-)|(^ey-)|(^ea-)|(^iy-)|(^ia-)|(^aw-)|(^ax-)|(^ah-)|(^hh-)|(^l-)|(^el-)|(^r-)|(^ua-)|(^ia-)|(^y-)'),
    ("L_Fricative",'(^s-)|(^sh-)|(^z-)|(^zh-)|(^f-)|(^v-)|(^th-)|(^dh-)'),
    ("L_Affricate",'(^ch-)|(^jh-)'),
    ("L_IVowel",'(^ih-)|(^iy-)|(^ia-)'),
    ("L_EVowel",'(^ey-)|(^ea-)|(^eh-)'),
    ("L_AVowel",'(^ae-)|(^aa-)|(^oh-)|(^er-)|(^ay-)|(^aw-)'),
    ("L_OVowel",'(^ao-)|(^oy-)|(^ow-)'),
    ("L_UVowel",'(^ax-)|(^ah-)|(^el-)|(^uh-)|(^uw-)|(^ua-)'),
    ("L_Voiced-Stop",'(^b-)|(^d-)|(^g-)'),
    ("L_Unvoiced-Stop",'(^p-)|(^t-)|(^k-)'),
    ("L_Front-Stop",'(^p-)|(^b-)'),
    ("L_Central-Stop",'(^t-)|(^d-)'),
    ("L_Back-Stop",'(^k-)|(^g-)'),
    ("L_Voiced-Fricative",'(^z-)|(^zh-)|(^dh-)|(^ch-)|(^v-)'),
    ("L_Unvoiced-Fricative",'(^s-)|(^sh-)|(^th-)|(^f-)|(^ch-)'),
    ("L_Front-Fricative",'(^f-)|(^v-)'),
    ("L_Central-Fricative",'(^s-)|(^z-)|(^th-)|(^dh-)'),
    ("L_Back-Fricative",'(^sh-)|(^zh-)|(^ch-)|(^jh-)'),
    ("L_ax",'(^ax-)'),
    ("L_ea",'(^ea-)'),
    ("L_ia",'(^ia-)'),
    ("L_ua",'(^ua-)'),
    ("L_ah",'(^ah-)'),
    ("L_ey",'(^ey-)'),
    ("L_b",'(^b-)'),
    ("L_r",'(^r-)'),
    ("L_iy",'(^iy-)'),
    ("L_v",'(^v-)'),
    ("L_t",'(^t-)'),
    ("L_ay",'(^ay-)'),
    ("L_d",'(^d-)'),
    ("L_z",'(^z-)'),
    ("L_ih",'(^ih-)'),
    ("L_l",'(^l-)'),
    ("L_aa",'(^aa-)'),
    ("L_sh",'(^sh-)'),
    ("L_ae",'(^ae-)'),
    ("L_er",'(^er-)'),
    ("L_jh",'(^jh-)'),
    ("L_n",'(^n-)'),
    ("L_aw",'(^aw-)'),
    ("L_p",'(^p-)'),
    ("L_s",'(^s-)'),
    ("L_uw",'(^uw-)'),
    ("L_ao",'(^ao-)'),
    ("L_k",'(^k-)'),
    ("L_eh",'(^eh-)'),
    ("L_m",'(^m-)'),
    ("L_ng",'(^ng-)'),
    ("L_y",'(^y-)'),
    ("L_ch",'(^ch-)'),
    ("L_w",'(^w-)'),
    ("L_hh",'(^hh-)'),
    ("L_f",'(^f-)'),
    ("L_ow",'(^ow-)'),
    ("L_g",'(^g-)'),
    ("L_dh",'(^dh-)'),
    ("L_oy",'(^oy-)'),
    ("L_th",'(^th-)'),
    ("L_uh",'(^uh-)'),
    ("L_zh",'(^zh-)'),
    ("R_Class-Stop",'([+]p$)|([+]b$)|([+]t$)|([+]d$)|([+]k$)|([+]g$)'),
    ("R_Nasal",'([+]m$)|([+]n$)|([+]ng$)'),
    ("R_FricatAffricative",'([+]s$)|([+]sh$)|([+]z$)|([+]zh$)|([+]f$)|([+]v$)|([+]ch$)|([+]jh$)|([+]th$)|([+]dh$)'),
    ("R_Liquid",'([+]l$)|([+]el$)|([+]r$)|([+]ua$)|([+]ia$)|([+]w$)|([+]y$)|([+]hh$)'),
    ("R_Vowel",'([+]ey$)|([+]ea$)|([+]eh$)|([+]ih$)|([+]ao$)|([+]ae$)|([+]aa$)|([+]oh$)|([+]uw$)|([+]ua$)|([+]uh$)|([+]er$)|([+]ay$)|([+]oy$)|([+]iy$)|([+]ia$)|([+]aw$)|([+]ow$)|([+]ax$)|([+]ah$)'),
    ("R_C-Front",'([+]p$)|([+]b$)|([+]m$)|([+]f$)|([+]v$)|([+]w$)'),
    ("R_C-Central",'([+]t$)|([+]d$)|([+]n$)|([+]s$)|([+]z$)|([+]zh$)|([+]th$)|([+]dh$)|([+]l$)|([+]el$)|([+]r$)|([+]ua$)|([+]ia$)'),
    ("R_C-Back",'([+]sh$)|([+]ch$)|([+]jh$)|([+]y$)|([+]k$)|([+]g$)|([+]ng$)|([+]hh$)'),
    ("R_V-Front",'([+]iy$)|([+]ia$)|([+]ih$)|([+]ey$)|([+]ea$)|([+]eh$)'),
    ("R_V-Central",'([+]ae$)|([+]oh$)|([+]aa$)|([+]er$)|([+]ao$)'),
    ("R_V-Back",'([+]uw$)|([+]ua$)|([+]uh$)|([+]ow$)|([+]ax$)|([+]ah$)'),
    ("R_Front",'([+]p$)|([+]b$)|([+]m$)|([+]f$)|([+]v$)|([+]w$)|([+]iy$)|([+]ia$)|([+]ih$)|([+]ey$)|([+]ea$)|([+]eh$)'),
    ("R_Central",'([+]t$)|([+]d$)|([+]n$)|([+]s$)|([+]z$)|([+]zh$)|([+]th$)|([+]dh$)|([+]l$)|([+]el$)|([+]r$)|([+]ua$)|([+]ia$)|([+]ae$)|([+]aa$)|([+]er$)|([+]ao$)'),
    ("R_Back",'([+]sh$)|([+]ch$)|([+]jh$)|([+]y$)|([+]k$)|([+]g$)|([+]ng$)|([+]hh$)|([+]oh$)|([+]uw$)|([+]ua$)|([+]uh$)|([+]ow$)|([+]ax$)|([+]ah$)'),
    ("R_Fortis",'([+]p$)|([+]t$)|([+]k$)|([+]f$)|([+]th$)|([+]s$)|([+]sh$)|([+]ch$)'),
    ("R_Lenis",'([+]b$)|([+]d$)|([+]g$)|([+]v$)|([+]dh$)|([+]z$)|([+]zh$)|([+]jh$)'),
    ("R_UnFortLenis",'([+]m$)|([+]n$)|([+]ng$)|([+]hh$)|([+]l$)|([+]el$)|([+]r$)|([+]ua$)|([+]ia$)|([+]y$)|([+]w$)'),
    ("R_Coronal",'([+]t$)|([+]d$)|([+]n$)|([+]th$)|([+]dh$)|([+]s$)|([+]z$)|([+]sh$)|([+]zh$)|([+]ch$)|([+]jh$)|([+]el$)|([+]l$)|([+]r$)|([+]ua$)|([+]ia$)'),
    ("R_NonCoronal",'([+]p$)|([+]b$)|([+]m$)|([+]k$)|([+]g$)|([+]ng$)|([+]f$)|([+]v$)|([+]hh$)|([+]y$)|([+]w$)'),
    ("R_Anterior",'([+]p$)|([+]b$)|([+]m$)|([+]t$)|([+]d$)|([+]n$)|([+]f$)|([+]v$)|([+]th$)|([+]dh$)|([+]s$)|([+]z$)|([+]l$)|([+]el$)|([+]w$)'),
    ("R_NonAnterior",'([+]k$)|([+]g$)|([+]ng$)|([+]sh$)|([+]zh$)|([+]hh$)|([+]ch$)|([+]jh$)|([+]r$)|([+]ua$)|([+]ia$)|([+]y$)'),
    ("R_Continuent",'([+]m$)|([+]n$)|([+]ng$)|([+]f$)|([+]v$)|([+]th$)|([+]dh$)|([+]s$)|([+]z$)|([+]sh$)|([+]zh$)|([+]hh$)|([+]l$)|([+]el$)|([+]r$)|([+]ua$)|([+]ia$)|([+]y$)|([+]w$)'),
    ("R_NonContinuent",'([+]p$)|([+]b$)|([+]t$)|([+]d$)|([+]k$)|([+]g$)|([+]ch$)|([+]jh$)'),
    ("R_Strident",'([+]s$)|([+]z$)|([+]sh$)|([+]zh$)|([+]ch$)|([+]jh$)'),
    ("R_NonStrident",'([+]f$)|([+]v$)|([+]th$)|([+]dh$)|([+]hh$)'),
    ("R_UnStrident",'([+]p$)|([+]b$)|([+]m$)|([+]t$)|([+]d$)|([+]n$)|([+]k$)|([+]g$)|([+]ng$)|([+]l$)|([+]el$)|([+]r$)|([+]ua$)|([+]ia$)|([+]y$)|([+]w$)'),
    ("R_Glide",'([+]hh$)|([+]l$)|([+]el$)|([+]r$)|([+]ua$)|([+]ia$)|([+]y$)|([+]w$)'),
    ("R_Syllabic",'([+]el$)|([+]er$)'),
    ("R_Unvoiced-cons",'([+]p$)|([+]t$)|([+]k$)|([+]s$)|([+]sh$)|([+]f$)|([+]th$)|([+]hh$)|([+]ch$)'),
    ("R_Voiced-cons",'([+]jh$)|([+]b$)|([+]d$)|([+]dh$)|([+]g$)|([+]y$)|([+]l$)|([+]el$)|([+]m$)|([+]n$)|([+]ng$)|([+]r$)|([+]ua$)|([+]ia$)|([+]v$)|([+]w$)|([+]z$)'),
    ("R_Unvoiced-all",'([+]p$)|([+]t$)|([+]k$)|([+]s$)|([+]sh$)|([+]f$)|([+]th$)|([+]hh$)|([+]ch$)'),
    ("R_Long",'([+]iy$)|([+]ia$)|([+]ow$)|([+]aw$)|([+]ao$)|([+]uw$)|([+]ua$)|([+]el$)'),
    ("R_Short",'([+]ae$)|([+]ey$)|([+]ea$)|([+]aa$)|([+]eh$)|([+]ih$)|([+]ay$)|([+]oy$)|([+]oh$)|([+]ax$)|([+]ah$)|([+]uh$)'),
    ("R_Dipthong",'([+]ey$)|([+]ea$)|([+]ay$)|([+]oy$)|([+]aw$)|([+]er$)|([+]el$)'),
    ("R_Front-Start",'([+]ey$)|([+]ea$)|([+]aw$)|([+]er$)'),
    ("R_Fronting",'([+]ay$)|([+]ey$)|([+]ea$)|([+]oy$)'),
    ("R_High",'([+]ih$)|([+]uw$)|([+]ua$)|([+]uh$)|([+]iy$)|([+]ia$)'),
    ("R_Medium",'([+]ey$)|([+]ea$)|([+]er$)|([+]ax$)|([+]ah$)|([+]ow$)|([+]eh$)|([+]el$)'),
    ("R_Low",'([+]ae$)|([+]ay$)|([+]aw$)|([+]aa$)|([+]oh$)|([+]ao$)|([+]oy$)'),
    ("R_Rounded",'([+]ao$)|([+]uw$)|([+]ua$)|([+]uh$)|([+]oy$)|([+]ow$)|([+]w$)'),
    ("R_Unrounded",'([+]eh$)|([+]ih$)|([+]ae$)|([+]aa$)|([+]oh$)|([+]er$)|([+]ay$)|([+]ey$)|([+]ea$)|([+]iy$)|([+]ia$)|([+]aw$)|([+]ax$)|([+]ah$)|([+]hh$)|([+]l$)|([+]el$)|([+]r$)|([+]ua$)|([+]ia$)|([+]y$)'),
    ("R_Fricative",'([+]s$)|([+]sh$)|([+]z$)|([+]zh$)|([+]f$)|([+]v$)|([+]th$)|([+]dh$)'),
    ("R_Affricate",'([+]ch$)|([+]jh$)'),
    ("R_IVowel",'([+]ih$)|([+]iy$)|([+]ia$)'),
    ("R_EVowel",'([+]ey$)|([+]ea$)|([+]eh$)'),
    ("R_AVowel",'([+]ae$)|([+]aa$)|([+]oh$)|([+]er$)|([+]ay$)|([+]aw$)'),
    ("R_OVowel",'([+]ao$)|([+]oy$)|([+]ow$)'),
    ("R_UVowel",'([+]ax$)|([+]ah$)|([+]el$)|([+]uh$)|([+]uw$)|([+]ua$)'),
    ("R_Voiced-Stop",'([+]b$)|([+]d$)|([+]g$)'),
    ("R_Unvoiced-Stop",'([+]p$)|([+]t$)|([+]k$)'),
    ("R_Front-Stop",'([+]p$)|([+]b$)'),
    ("R_Central-Stop",'([+]t$)|([+]d$)'),
    ("R_Back-Stop",'([+]k$)|([+]g$)'),
    ("R_Voiced-Fricative",'([+]z$)|([+]zh$)|([+]dh$)|([+]ch$)|([+]v$)'),
    ("R_Unvoiced-Fricative",'([+]s$)|([+]sh$)|([+]th$)|([+]f$)|([+]ch$)'),
    ("R_Front-Fricative",'([+]f$)|([+]v$)'),
    ("R_Central-Fricative",'([+]s$)|([+]z$)|([+]th$)|([+]dh$)'),
    ("R_Back-Fricative",'([+]sh$)|([+]zh$)|([+]ch$)|([+]jh$)'),
    ("R_ax",'([+]ax$)'),
    ("R_ea",'([+]ea$)'),
    ("R_ia",'([+]ia$)'),
    ("R_ua",'([+]ua$)'),
    ("R_ah",'([+]ah$)'),
    ("R_ey",'([+]ey$)'),
    ("R_b",'([+]b$)'),
    ("R_r",'([+]r$)'),
    ("R_iy",'([+]iy$)'),
    ("R_v",'([+]v$)'),
    ("R_t",'([+]t$)'),
    ("R_ay",'([+]ay$)'),
    ("R_d",'([+]d$)'),
    ("R_z",'([+]z$)'),
    ("R_ih",'([+]ih$)'),
    ("R_l",'([+]l$)'),
    ("R_aa",'([+]aa$)'),
    ("R_sh",'([+]sh$)'),
    ("R_ae",'([+]ae$)'),
    ("R_er",'([+]er$)'),
    ("R_jh",'([+]jh$)'),
    ("R_n",'([+]n$)'),
    ("R_aw",'([+]aw$)'),
    ("R_p",'([+]p$)'),
    ("R_s",'([+]s$)'),
    ("R_uw",'([+]uw$)'),
    ("R_ao",'([+]ao$)'),
    ("R_k",'([+]k$)'),
    ("R_eh",'([+]eh$)'),
    ("R_m",'([+]m$)'),
    ("R_ng",'([+]ng$)'),
    ("R_y",'([+]y$)'),
    ("R_ch",'([+]ch$)'),
    ("R_w",'([+]w$)'),
    ("R_hh",'([+]hh$)'),
    ("R_f",'([+]f$)'),
    ("R_ow",'([+]ow$)'),
    ("R_g",'([+]g$)'),
    ("R_dh",'([+]dh$)'),
    ("R_oy",'([+]oy$)'),
    ("R_th",'([+]th$)'),
    ("R_uh",'([+]uh$)'),
    ("R_zh",'([+]zh$)')
    
    ]
