#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright 2012,2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

from cart import cart
import sys

if len(sys.argv) != 9:
    sys.exit(('%s <imodel> <omodel> <occs> <tiedlist>'+
              ' <freephos> <min_occ> <min_inc> <queries>')%sys.argv[0])
amodel_fn= sys.argv[1]
amodel_out_fn= sys.argv[2]
occs_fn= sys.argv[3]
tiedlist_fn= sys.argv[4]
freephos= set([x.strip() for x in sys.argv[5].split(',')])
min_occ= float(sys.argv[6])
if min_occ<=0:sys.exit('%s: min_occ must be positive'%sys.argv[0])
min_inc= float(sys.argv[7])
if min_inc<=0:sys.exit('%s: min_inc must be positive'%sys.argv[0])
queries= eval(open(sys.argv[8]).read())

cart ( amodel_fn= amodel_fn,
       occs_fn= occs_fn,
       queries= queries,
       tiedlist_fn= tiedlist_fn,
       amodel_out_fn= amodel_out_fn,
       use_long_names= 0,
       verbose= 4,
       min_occ= min_occ,
       min_inc= min_inc,
       freephos= freephos )
