#!/bin/bash

# Copyright 2012,2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

. mhtrain_em_prolog.sh

function print_help {
    cat <<EOF
$0 [options] <tmpdir> <input-model> <mix-count>

  <tmpdir>        Temporal directory of the estimation
  <input-model>   Path of the model to split (extensions will be added)
  <mix-counts>    Mixture counts of the input model

  -e <tLmumix_ex> Path to tLmumix execuable
  -m <min-occs>   Minimum number of samples required to split mixture
EOF
}

NUMARGS=2
TLMUMIX="tLmumix"
MINOCCS=30
while getopts "he:d:" OPT
do
  case $OPT in
        h) print_help; exit 0;;
        e) TLMUMIX="$OPTARG";;
        d) MINOCCS=$OPTARG;;
  esac
done
[ $[$#-OPTIND+1] -eq $NUMARGS ] || { print_help >&2; exit 1; }
shift $[OPTIND-1]

TMP=$1
MODEL=$2

#Double the mixtures
$TLMUMIX 0 -i $MODEL.model -o $TMP/model_0 \
    -c $MODEL.mixcounts -m $MINOCCS
