#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright 2012,2013,2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

from array import array
from math import log
from TLK import *
import sys

class Tri:
    def __init__ ( self, name ):
        self.name= name
        aux= name.split('-')
        aux= aux[1] if len(aux)>1 else aux[0]
        aux= aux.split('+')
        aux= aux[0] if len(aux)>1 else aux[0]
        self.center= aux
    def __repr__ (self):return "'%s'"%self.name
    
if len(sys.argv) != 3:
    sys.exit('%s <model> <trifonemes format htk> > <model_htk>'%sys.argv[0])

# Carrega els trifonemes
tokens= file(sys.argv[2]).read().split()
tris= []
for t in tokens:
    tri= Tri(t.strip())
    tris.append(tri)

# Carrega el model i obté els caràcters.
m= AModel(file(sys.argv[1]))
hmms= dict([(m.labels[i],m.hmms[i]) for i in xrange(0,m.N)])

# Crea el model de trifonemes
def ow(str) : sys.stdout.write(str)
def own(str) : ow(str+'\n')
def print_list_trans(Q,state):
    for e in state.edges:
        own('  %d %g'%(e.q+1,log(e.p)))
    if state.fp > 0.0 :
        own('  F %g'%log(state.fp))
    own('.')
own('AMODEL')
own('DGaussian')
own('D %d'%m.D)
ow('SMOOTH')
for d in xrange(0,m.D):ow(' %g'%m.smooth[d])
ow('\n')
own('N %d'%len(tris))
atrans= {}
for tri in tris:
    c= hmms[tri.center]
    own("'%s'"%tri.name)
    own('Q %d'%c.Q)
    ptr= atrans.get(tri.center)
    if ptr != None : own('TransP %s'%ptr)
    else:
        atrans[tri.center]= tri.name
        if c.trans.type == Trans.LINEAL or c.trans.type == Trans.LIST :
            c.trans.write ( sys.stdout )
        else: sys.exit('unknown transition type')
    for s in c.states: s.write ( sys.stdout, m )
