#!/usr/bin/env python
# -*- coding: utf-8 -*-

#
#  Copyright 2014 transLectures-UPV Team
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#

from sys import argv
import commands
from TLK import *
import sys

def tiedState2PhysState (filename):
  f = open(filename, "r")
  m = AModel(f)
  res=[]
#  print m.members_args.names[0]
  for n in xrange(0,m.N):
    for q in xrange(0,m.hmms[n].Q):
#      print str(m.labels[n])+" "+str(q)+" "+str(m.hmms[n].states[q].name)
      res.append(str(m.labels[n])+" "+str(q)+" "+str(m.hmms[n].states[q].name))
  f.close()
  return res

#def wrapPhos( tiedPhys ):
#  pho={}
#  state={}
#  for l in tiedPhys:
#    pho[str(l.split(" ")[0])+str(" ")+str(l.split(" ")[1])] = l.split(" ")[2]
#    state[l.split(" ")[2]] = 1
#  statesNumber = len(state)
#  for s in xrange(0,len(state.keys())):
#    state[state.keys()[s]]=s
#  for k in pho.keys():
#    pho[k] = state[pho[k]]
#  return [pho,statesNumber]


def wrapPhos( tiedPhys, filename ):
  f = open(filename, "r")
  m = AModel(f)
  pho={}
  state={}
  count = 0
  for l in tiedPhys:
    pho[str(l.split(" ")[0])+str(" ")+str(l.split(" ")[1])] = l.split(" ")[2]
    state[l.split(" ")[2]] = m.members_args.names.index(l.split(" ")[2]);
  statesNumber = len(state)
  for k in pho.keys():
#    print str(pho[k])+" = "+str(state[pho[k]])
    pho[k] = state[pho[k]]
  return [pho,statesNumber]

def labelFrames( filename, pho, statesNumber ):
  f = open(filename, "r")
  labeled = 0
  res = []
  for l in f.xreadlines():
    words=l.split(" ")
    key=str(words[0])+str(" ")+str(words[1])
    if key in pho:
      labeled = labeled + int(words[3])
      res.append(str(words[2])+" "+str(words[3])+" : "+str(pho[key])+" "+str(words[4].strip()))
#      print str(key)+" = "+str(pho[key])
    else:
      print "[ERR] Could not find attached state in the states table"
      print "Key: ", key
      exit()
  f.close()
  print "LABELS %s %s"%( statesNumber, labeled )
  for l in res:
    print l

if len(argv) != 3:
  print "Usage: "+argv[0]+" <amodel> <states align>"
  exit()

pho={}
statesNumber=0
tiedPhys=[]
tiedPhys=tiedState2PhysState(argv[1])
[pho,statesNumber]=wrapPhos( tiedPhys, argv[1] )
labelFrames( argv[2], pho, statesNumber )
