/*
 *  Copyright 2013,2014 transLectures-UPV Team
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  Miguel Ángel del Agua Teba - mdelagua@dsic.upv.es, madelagua@gmail.com
 *  Jesús Andrés Ferrer - jandres@dsic.upv.es
 *  Adrià Giménez Pastor - agimenez@dsic.upv.es
 */

#include "msg.h"

//MESSAGE msg;

MESSAGE& MESSAGE::end() {
  cerr << "[II] " << ss.str() << endl;
  ss.str("");
  return *this;
}

MESSAGE& MESSAGE::end(const string & mode) {
  cerr << mode << " " << ss.str() << endl;
  ss.str("");
  return *this;
}

void MESSAGE::info(const string text, ostream & out) {
  out << "[II] " << text << endl;
}

void MESSAGE::info(const string text) {
  cerr << "[II] " << text << endl;
}

void MESSAGE::debug(const string text, ostream & out) {
  out << "[GG] " << text << endl;
}

void MESSAGE::debug(const string text) {
  cerr << "[GG] " << text << endl;
}

void MESSAGE::warning(const string text, ostream & out) {
  out << "[WW] " << text << endl;
}

void MESSAGE::warning(const string text) {
  cerr << "[WW] " << text << endl;
}

void MESSAGE::error(const string text, ostream & out) {
  out << "[EE] " << text << endl;
}

void MESSAGE::error(const string text) {
  cerr << "[EE] " << text << endl;
}
