/*
 *  Copyright 2013,2014 transLectures-UPV Team
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  Miguel Ángel del Agua Teba - mdelagua@dsic.upv.es, madelagua@gmail.com
 *  Jesús Andrés Ferrer - jandres@dsic.upv.es
 *  Adrià Giménez Pastor - agimenez@dsic.upv.es
*/ 

#include <cstring>
#include <sstream>
#include <iostream>

using namespace std;

#ifndef MSG
#define MSG

/*
 * =====================================================================================
 *        Class:  MSG
 *  Description:  Message provider class
 * =====================================================================================
 */
class MESSAGE
{
public:
  MESSAGE() :
      ss() {
  } ///< Constructor that initilialises a new MSG provider
  void info(const string, ostream &); ///< Writes an info message in the specified output stream
  void info(const string); ///< Writes an info message in the default error stream
  void debug(const string, ostream &); ///< Writes a debug message in the specified output stream
  void debug(const string); ///< Writes a debug message in the default error stream
  void warning(const string, ostream &); ///< Writes a warning  message in the specified output stream
  void warning(const string); ///< Writes a warning  message in the default error stream
  void error(const string, ostream &); ///< Writes an error message in the specified output stream
  void error(const string); ///< Writes an error message in the default error stream
  template<class T> MESSAGE& operator<<(const T & val) {
    ss << val;
    return *this;
  }
  MESSAGE& operator<<(MESSAGE & (*f)(MESSAGE&)) {
    return f(*this);
  }
  MESSAGE& end();
  MESSAGE& end(const string& mode);
  /* void end( string mode, ostream & out ){
   cerr << mode << " " << ss.str() << endl;
   ss.str("");
   } */
  static MESSAGE& warning(MESSAGE & val) {
    return val.end("[WW]");
  }
  static MESSAGE& info(MESSAGE & val) {
    return val.end("[II]");
  }
  static MESSAGE& debug(MESSAGE & val) {
    return val.end("[GG]");
  }
  static MESSAGE& error(MESSAGE & val) {
    return val.end("[EE]");
  }
private:
  stringstream ss;
};
/* -----  end of class MSG  ----- */

//extern MESSAGE mesg;
#endif
