/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  get_pbm_lst.c - Implementació de 'get_pbm_lst.h'.
 *
 *  Adrià Giménez Pastor, 2008,2011,2013.
 *
 */


#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>

/* i18n includes and defines */
#include <locale.h>
#include "intl.h"

#include "get_pbm_lst.h"
#include "macros.h"




tLFileList *
get_pbm_lst (
	     const char *name,
	     const int   verbose
	     )
{
  
  tLFileList *fl;
  size_t n;
  
  
  fl= tL_filelist_new_from_file ( name );
  if ( fl == NULL ) tL_error ( _("Could not open '%s'"), name );
  if ( verbose )
    {
      fprintf ( stderr, _("The sample list has been read\n") );
      if ( verbose > 2 )
	{
	  for ( n= 0; n < fl->N; ++n )
	    fprintf ( stderr, "  - %lu: \"%s\"\n",
		      _PS(n), fl->files[n] );
	}
    }
  
  return fl;
  
} /* end get_pbm_lst */
