/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  itertrain.h - Per a fer una iteració de EM.
 *
 *  Adrià Giménez Pastor, 2008,2009,2011.
 *
 */

#ifndef __ITERTRAIN_H__
#define __ITERTRAIN_H__

#include <libTLK/TLK.h>

typedef struct
{
  
  tLFea        **feas;
  int           *index;
  unsigned int   size;
  unsigned int   N;
  
} feablock_t;

feablock_t *
create_feablock (
		 const unsigned int  size,
		 const tLAModel     *amodel
		 );

void
free_feablock (
	       feablock_t *feablock
	       );

tLProb
itertrain (
	   tLTrainer  *trainer,
	   feablock_t *feablock,
	   tLFileList *pbm_lst,
	   tLTar      *tar,
	   int         verbose
	   );

#endif /* __ITERTRAIN_H__ */
