/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  global.h - Mètodes pers als tipus que no tinguen 'global'.
 *
 *  Adrià Giménez Pastor, 2008,2011,2012,2013.
 *
 */

#ifndef __TL_PRV_AMCOUNTS__GLOBAL_H__
#define __TL_PRV_AMCOUNTS__GLOBAL_H__

#include <stdio.h>

#include "amcounts_aux.h"
#include "common.h"
#include "text.h"

void *
tL_amcounts_create_global_empty (
				 void      *global,
				 const int  mllrinfo
				 );

void
tL_amcounts_free_global_empty (
			       void *cglobal,
			       void *global
			       );

void
tL_amcounts_print_error (
			 FILE               *to,
			 void               *global,
			 void               *cglobal,
			 void               *states,
			 void               *cstates,
			 const unsigned int  Q,
			 const tLBool        binary
			 );

int
tL_amcounts_accum_error (
			 FILE               *from,
			 tLBuffer           *buffer,
			 void               *global,
			 void               *cglobal,
			 void               *states,
			 void               *cstates,
			 const unsigned int  Q,
			 const tLBool        binary,
			 unsigned long      *counter
			 );

void
tL_update_global_empty (
			void *global,
			void *cglobal
			);

#endif /* __TL_PRV_AMCOUNTS__GLOBAL_H__ */
