/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  amodel.h - Definició del model de caràcters i algunes funcions
 *             bàsiques.
 *
 *  Adrià Giménez Pastor, 2008,2009,2010,2011.
 *
 */

#ifndef __TL_PRV_AMODEL_H__
#define __TL_PRV_AMODEL_H__

#include "amodel_public.h"
#include "common.h"
#include "samples.h"
#include "text.h"


/* DEFINICIÓ */

#define FLINEAL  0x1
#define FLIST    0x2
#define FPOINTER 0x4

#define AMODELNULLEDGE ((tLAModelTransListEdge *)NULL)

typedef struct
{
  
  const char            *name;     /* Nom del tipus. */
  const tLAModelMethods *meths;    /* Mètodes. */
  
} amodel_type_t;


/* FUNCIONS */

/* Els estats estan per inicialitzar. Crea un caracter per cada símbol
   de Q estats. */
tLAModel *
tL_create_amodel_empty (
			const char         *type,
			const tLDict       *syms,
			const unsigned int  Q
			);

/* Els estats estan per inicialitzar. Crea un caracter per cada símbol
   amb el numero d'estats que li corresponga segons el vector. */
tLAModel *
tL_create_amodel_empty_vs (
			   const char         *type,
			   const tLDict       *syms,
			   const unsigned int *Qs
			   );

/* Busca si existeix un tipus amb el nom
 * indicat.
 */
amodel_type_t
tL_search_amodel_type (
		       const char *name
		       );

#endif /* __TL_PRV_AMODEL_H__ */
