/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  global.c - Implementació de 'global.h'.
 *
 *  Adrià Giménez Pastor, 2008,2009,2011,2012.
 *
 */


#include <stddef.h>

/* i18n includes and defines */
#include <locale.h>
#include "../../intl.h"

#include "global.h"




/**********************/
/* FUNCIONS PÚBLIQUES */
/**********************/

tLBool
tL_test_empty (
	       void         *global,
	       const tLFea  *fea,
	       char        **err
	       )
{
  return TRUE;
} /* end tL_test_empty */


tLFeaType
tL_get_fea_type_pbm (
		     void *global
		     )
{
  return TL_FEA_BINARY;
} /* end tL_get_fea_type_pbm */


tLFeaType
tL_get_fea_type_real (
		      void *global
		      )
{
  return TL_FEA_REAL;
} /* end tL_get_fea_type_real */


void
tL_smooth_global_empty (
			void          *global,
			const tLFloat  f
			)
{
} /* end tL_smooth_states_empty */


void
tL_smooth_states_empty (
			void               *global,
			void               *states,
			const unsigned int  Q,
			const tLFloat       f
			)
{
} /* end tL_smooth_states_empty */


void *
tL_copy_global_error (
                      void *global
                      )
{
  tL_error ( _( " copy is not implemented " ) );
  return NULL;
} /* end tL_copy_global_error */


void
tL_copy_states_error (
		      void               *global,
		      void               *src_states,
		      void               *dst_states,
		      const unsigned int  src_begin,
		      const unsigned int  dst_begin,
		      const unsigned int  Q
		      )
{
  tL_error ( _( " copy is not implemented " ) );
} /* end tL_copy_states_error */
