/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  global.h - Mètodes globals que no fan res.
 *
 *  Adrià Giménez Pastor, 2008,2009,2011,2012.
 *
 */

#ifndef __TL_PRV_AMODEL__GLOBAL_H__
#define __TL_PRV_AMODEL__GLOBAL_H__

#include <stdio.h>

/* i18n includes and defines */
#include <locale.h>
#include "../../intl.h"

#include "../common.h"
#include "../error.h"
#include "../samples.h"
#include "../text.h"

/* MACROS */

#define MSGERR_TOK(ERR,TOK,Q,SYM)					\
  tL_msgerror ( ERR, _( "Unable to read the token %s in the %uth"		\
		" state of the symbol '%s'" ) , TOK, (Q)+1, SYM )

#define MSGERR_GTOK(ERR,TOK) TLMSG_GTOK ( ERR, TOK )

#define MSGERR_DESC(ERR,DESC,Q,SYM)				\
  tL_msgerror ( ERR, _( "Unable to read %s of the %uth state"	\
		" in the symbol '%s'" ) , DESC, (Q)+1, sym )

#define MSGERR_DESCS(ERR,DESC,SYM)				\
  tL_msgerror ( ERR, _( "Unable to read %s of the symbol '%s'" ) ,	\
		DESC, sym )

#define MSGERR_GDESC(ERR,DESC) TLMSG_GDESC ( ERR, DESC )

#define MSGERR_VAL(ERR,NAME,I,Q,SYM)				\
  tL_msgerror ( ERR, _( "Unable to read %s[%u] in the %uth state"	\
		" of the symbol '%s'" ) , NAME, I, (Q)+1, sym )

#define MSGERR_GVAL(ERR,NAME,I)				\
  tL_msgerror ( ERR, _( "Unable to read %s[%u]" ) , NAME, I )

#define MSGERR_DESC0(ERR,DESC,Q,SYM)				\
  tL_msgerror ( ERR, _( "In the %uth state of symbol '%s',"	\
		" %s cannot be 0" ) , (Q)+1, sym, DESC )

#define MSGERR_GDESC0(ERR,DESC)					\
  tL_msgerror ( ERR, _( "%s cannot be 0" ) , DESC )

#define MSGERR_UT(ERR,TYPE)			\
  tL_msgerror ( ERR, _( "Unknown type %s" ) , TYPE )


/* FUNCIONS */

tLBool
tL_test_empty (
	       void         *global,
	       const tLFea  *fea,
	       char        **err
	       );

tLFeaType
tL_get_fea_type_pbm (
		     void *global
		     );

tLFeaType
tL_get_fea_type_real (
		      void *global
		      );

void
tL_smooth_global_empty (
			void          *global,
			const tLFloat  f
			);

void
tL_smooth_states_empty (
			void               *global,
			void               *states,
			const unsigned int  Q,
			const tLFloat       f
			);

void *
tL_copy_global_error (
		      void *global
		      );

void
tL_copy_states_error (
		      void               *global,
		      void               *src_states,
		      void               *dst_states,
		      const unsigned int  src_begin,
		      const unsigned int  dst_begin,
		      const unsigned int  Q
		      );

#endif /* __TL_PRV_AMODEL__GLOBAL_H__ */
