/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  mixture.h - Mixtura.
 *
 *  Adrià Giménez Pastor, 2008,2010,2011.
 *
 */

#ifndef __TL_PRV_AMODELS__MIXTURE_H__
#define __TL_PRV_AMODELS__MIXTURE_H__

#include "../amodel.h"
#include "../common.h"


/* MACROS */

#define MIXTURE_GLOBAL(ptr) ((mixture_global_t *) (ptr))
#define MIXTURE_STATE(ptr) ((mixture_state_t *) (ptr))


/* TIPUS */

typedef struct
{
  
  unsigned int  I;          /* Número de components. */
  tLProb       *p;          /* |I|. Probabilitats de
			       les components. */
  void         *members;    /* |I|. Components. */
  
} mixture_state_t;

typedef struct
{
  
  const char            *type;      /* Tipus de les components. */
  void                  *global;    /* Atributs globals de les
				       components. */
  const tLAModelMethods *meths;     /* Mètodes de les components. */
  unsigned int           max_I;     /* Número màxim de components en
				       un estat. */
  
} mixture_global_t;


/* MÈTODES */

extern const tLAModelMethods tL_mixture_methods;


#endif /* __TL_PRV_AMODELS__MIXTURE_H__ */
