/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  tiedstates.h - Estats lligats.
 *
 *  Adrià Giménez Pastor, 2011.
 *
 */

#ifndef __TL_PRV_AMODELS__TIEDSTATES_H__
#define __TL_PRV_AMODELS__TIEDSTATES_H__

#include "../amodel.h"
#include "../common.h"
#include "../text.h"


/* MACROS */

#define TIEDSTATES_GLOBAL(ptr) ((tiedstates_global_t *) (ptr))
#define TIEDSTATES_STATE(ptr) ((tiedstates_state_t *) (ptr))


/* TIPUS */

typedef unsigned int tiedstates_state_t;

typedef struct
{
  
  const char            *type;      /* Tipus dels estats. */
  void                  *global;    /* Atributs globals dels estats. */
  const tLAModelMethods *meths;     /* Mètodes dels estats. */
  unsigned int           N;         /* Número d'estats. */
  void                  *states;    /* |N|. Estats. */
  tLDict                *names;     /* Noms dels estats. */
  
} tiedstates_global_t;


/* MÈTODES */

extern const tLAModelMethods tL_tiedstates_methods;


#endif /* __TL_PRV_AMODELS__TIEDSTATES_H__ */
