/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  calc.c - Implementació de 'calc.h'.
 *
 *  Adrià Giménez Pastor, 2008,2010,2011,2012.
 *
 */


#include "calc.h"




/**********************/
/* FUNCIONS PÚBLIQUES */
/**********************/

tLFloat
tL_radd (
	 const tLFloat a,
	 const tLFloat b
	 )
{
  /*
  return (a > b ) ?
    (a + log ( 1.0 + exp ( b - a ) )) :
    (b + log ( exp ( a - b ) + 1.0 ));
  */
  
  tLFloat aux;
  
  
  if ( a > b )
    {
      if ( (aux= b-a) < LOGEPS ) return a;
      return a + log ( 1.0 + exp ( aux ) );
    }
  else
    {
      if ( (aux= a-b) < LOGEPS ) return b;
      return b + log ( exp ( aux ) + 1.0 );
    }
  
} /* end tL_radd */


tLFloat
tL_radd1 (
	  const tLFloat a
	  )
{
  
  return (a > 0.0 ) ?
    (a + log ( 1.0 + exp ( -a ) )) :
    (log ( exp ( a ) + 1.0 ));
  
} /* end tL_radd1 */


tLFloat
tL_radd_vals (
	      const tLFloat *vals,
	      const tLFloat  max,
	      const long     N
	      )
{
  
  long n;
  tLFloat res, aux;
  
  
  res= 0.0;
  for ( n= 0; n < N; ++n )
    {
      if ( (aux= vals[n]-max) >= LOGEPS )
	res+= exp ( aux );
    }
  
  return max + log ( res );
  
} /* end tL_radd_vals */
