/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  calc.h - Funcions i macros de càlcul.
 *
 *  Adrià Giménez Pastor, 2008,2011,2012.
 *
 */

#ifndef __TL_PRV_CALC_H__
#define __TL_PRV_CALC_H__

#include <math.h>

#include "common.h"


/* MACROS */

#define MINLOG -708.396
#define LOGEPS -36.0437 /*-43.6683*/

#define RADD(a,b)                                           \
  (((a) == -HUGE_VAL) ? (b) :				    \
   (((b) == -HUGE_VAL) ? (a) :				    \
    tL_radd ( (a), (b) )))

#define RADD1(a)                               \
  (((a) == -HUGE_VAL) ? 0.0 :		       \
   tL_radd1 ( (a) ))

#define RADD_VALS(vals,max,N)                 \
  (((max) != -HUGE_VAL) ?		      \
   tL_radd_vals ( (vals), (max), (N) ) :      \
   -HUGE_VAL)


/* FUNCIONS */

tLFloat
tL_radd (
	 const tLFloat a,
	 const tLFloat b
	 );

tLFloat
tL_radd1 (
	  const tLFloat a
	  );

tLFloat
tL_radd_vals (
	      const tLFloat *vals,
	      const tLFloat  max,
	      const long     N
	      );


#endif /* __TL_PRV_CALC_H__ */
