/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  mixture.h - Mixtura.
 *
 *  Adrià Giménez Pastor, 2008,2011.
 *
 */

#ifndef __TL_PRV_CALCELPROB__MIXTURE_H__
#define __TL_PRV_CALCELPROB__MIXTURE_H__

#include "../calcelprob.h"

/* Mixture Max Probability. */
typedef struct
{
  
  tLProb       p;    /* Probabilitat. */
  unsigned int i;    /* Component. */
  
} mmprob_t;

calcelprob_t *
tL_alloc_mixture_calcelprob (
			     void       *global,
			     const int   flags,
			     char      **err
			     );

mmprob_t
tL_Mixture_calcelprob_calcmm (
			      calcelprob_t        *cep,
			      void                *global,
			      void                *states,
			      const unsigned int   q,
			      const tLFea         *fea,
			      const int            t
			      );

#endif /* __TL_PRV_CALCELPROB__MIXTURE_H__ */
