/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  check_is_mixture.c - Implementació de 'check_is_mixture.h'.
 *
 *  Adrià Giménez Pastor, 2012.
 *
 */


#include <stddef.h>
#include <stdlib.h>
#include <string.h>

/* i18n includes and defines */
#include <locale.h>
#include "../intl.h"

#define __TL_PRV
#include "check_is_mixture.h"
#include "amodel/mixture.h"
#include "amodel/tiedstates.h"
#include "error.h"
#include "mem.h"




tLBool
tL_check_is_mixture (
		     const tLAModel  *amodel,
		     int             *type,
		     char           **err
		     )
{
  
  if ( !strcmp ( "Mixture", amodel->type ) ) *type= MIXTURE;
  else if ( !strcmp ( "TiedStates", amodel->type ) )
    {
      if ( !strcmp ( "Mixture", TIEDSTATES_GLOBAL(amodel->global)->type ) )
	*type= TIEDSTATES;
      else
        {
          tL_msgerror ( err, _( "Characters must be of type Mixture or,"
                        " TiedStates-Mixture but they are of type"
                        " TiedStates-%s" ) ,
                        TIEDSTATES_GLOBAL(amodel->global)->type );
          return FALSE;
        }
    }
  else
    {
      tL_msgerror ( err, _( "Characters must be of type Mixture or,"
                    " TiedStates-Mixture but they are of type %s" ) ,
                    amodel->type );
      return FALSE;
    }
  
  return TRUE;
  
} /* end tL_check_is_mixture */
