/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  cmllr_alg.h - Algorisme CMLLR per a matrius completes partint de
 *                Gaussianes diagonals.
 *
 *  Miguel Ángel del Agua Teba
 */

#ifndef __CMLLR_ALG_FULL_H__
#define __CMLLR_ALG_FULL_H__

#include "cmllr_alg.h"
#include "amcounts/dgaussian.h"
#include "amodel/dgaussian.h"
#include "common.h"

typedef struct {
  
  double     ***G;
  double       *p;
  double      **A;
  double      **k;
  double       *b;
  double       *e12;
  int           *ipiv;
  double       *waux;
  double       *waux2;
  
} cmllr_alg_full_data_t ;

void
tL_cmllr_alg_full_data_alloc (
			      cmllr_alg_full_data_t *mem_vars,
			      uint                   D
			      );

void
tL_cmllr_alg_full_data_free (
			     cmllr_alg_full_data_t *mem_vars
			     );

int
tL_cmllr_alg_full (
		   const cmllr_alg_paramscounts_t    *pcs,
		   const dgaussian_global_t          *global,
		   const uint                         niters,
		   double                          **W,
		   cmllr_alg_full_data_t             *mem_vars,
		   char                             **err
		   );

#endif /* __CMLLR_ALG_FULL_H__ */
