/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  common.c - Implementació de 'common.h'.
 *
 *  Adrià Giménez Pastor, 2008,2010,2011.
 *
 */


#include <math.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <zlib.h>

#include "common.h"
#include "error.h"
#include "mem.h"




/**********************/
/* FUNCIONS PÚBLIQUES */
/**********************/

TL_API_FUNC(tLProb)
tL_atop (
	 const char *str
	 )
{
  
  if ( strcmp ( "-INF", str ) )
    return (tLProb) atof ( str );
  else
    return (tLProb) -HUGE_VAL;
  
} /* end tL_atop */


void
tL_print_string_binary (
			FILE       *to,
			const char *string
			)
{
  
  size_t length;
  
  
  length= strlen ( string );
  fwritee ( &length, sizeof(size_t), 1, to );
  fwritee ( string, 1, length, to );
  
} /* end tL_print_string_binary */


char *
tL_read_string_binary (
		       gzFile from
		       )
{
  
  size_t length;
  char *ret;
  
  
  ret= NULL;
  if ( gzread ( from, &length, sizeof(size_t) ) != sizeof(size_t) ||
       length == 0 || length+1 == 0 ) goto tL_error;
  mt ( ret= mem_alloc ( char, length+1 ) );
  if ( gzread ( from, ret, length ) != length ) goto tL_error;
  ret[length]= '\0';
  
  return ret;
  
 tL_error:
  if ( ret != NULL ) free ( ret );
  return NULL;
  
} /* end tL_read_string_binary */


TL_API_FUNC(void)
tL_prob_print (
	       const tLProb  prob,
	       FILE         *to
	       )
{
  
  if ( prob == -HUGE_VAL ) fprintf ( to, "-INF" );
  else fprintf ( to, "%g", (double) prob );
  
} /* end tL_prob_print */
