/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  create_nstates.c - Implementació de 'create_nstates.h'.
 *
 *  Adrià Giménez Pastor, 2008,2011.
 *
 */


#include <stddef.h>
#include <stdlib.h>

#include "create_nstates.h"
#include "error.h"
#include "mem.h"




size_t *
tL_create_nstates (
		   const tLDict   *cseqs,
		   const tLAModel *amodel
		   )
{
  
  size_t *ret, n, t;
  tLSeq cs;
  
  
  mt ( ret= mem_alloc ( size_t, cseqs->N ) );
  for ( n= 0; n < cseqs->N; ++n )
    {
      ret[n]= 0;
      cs= *(dict_GCSEQ ( cseqs, n ));
      for ( t= 0; t < cs.length; ++t )
	ret[n]+= amodel->hmms[cs.v[t]].Q;
    }
  
  return ret;
  
} /* end tL_create_nstates */
