/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  eprobs.h - Estructura per a no tenir que recalcular probabilitats
 *             d'emissió.
 *
 *  Adrià Giménez Pastor, 2008,2009,2011.
 *
 */

#ifndef __TL_PRV_EPROBS_H__
#define __TL_PRV_EPROBS_H__

#include "calcelprob.h"
#include "amodel.h"
#include "common.h"
#include "samples.h"
#include "text.h"


/* DEFINICIÓ */

struct eprob
{
  
  tLProb prob;
  tLBool active;
  
};

typedef struct
{
  
  struct eprob ***p;
  int             length;
  calcelprob_t   *cep;
  
} eprobs_t;


/* FUNCIONS */

eprobs_t *
tL_create_eprobs (
		  const tLAModel  *amodel,
		  char           **err
		  );

tLProb
tL_eprobs_lprob (
		 eprobs_t           *eprobs,
		 const tLAModel     *amodel,
		 const tLFea        *fea,
		 const unsigned int  c,
		 const unsigned int  q,
		 const int           t
		 );

void
tL_free_eprobs (
		eprobs_t *eprobs
		);

/* Suposant que està 'resetejat', prepara eprobs per a una nova
 * imatge.
 */
#define init_eprobs(EPROBS,AMODEL,FEA)					\
  init_calcelprob ( (EPROBS)->cep, (AMODEL),(FEA), 0, (FEA)->cols )

void
tL_reset_eprobs (
		 eprobs_t       *eprobs,
		 const tLAModel *amodel,
		 const int       length
		 );

/* Sols si és necessari. */
void
tL_resize_eprobs (
		  eprobs_t       *eprobs,
		  const tLAModel *amodel,
		  const int       length
		  );


#endif /* __TL_PRV_EPROBS_H__ */
