/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  eprobst.h - Igual que 'eprobs.h' però sols emmagatzema per al
 *              frame actual.
 *
 *  Adrià Giménez Pastor, 2011.
 *
 */

#ifndef __TL_PRV_EPROBST_H__
#define __TL_PRV_EPROBST_H__

#include "calcelprob.h"
#include "amodel.h"
#include "common.h"
#include "samples.h"
#include "text.h"


/* DEFINICIÓ */

typedef struct
{
  
  tLBool a;
  tLProb p;
  
} eprobst_node_t;

typedef struct
{
  
  eprobst_node_t **nodes;    /* |C|*|Q|. */
  eprobst_node_t **stack;
  size_t           N;
  calcelprob_t    *cep;
  
} eprobst_t;


/* FUNCIONS */

eprobst_t *
tL_create_eprobst (
		   const tLAModel  *amodel,
		   const tLBool     viterbi_states,
		   char           **err
		   );

tLProb
tL_eprobst_lprob (
		  eprobst_t          *eprobst,
		  const tLAModel     *amodel,
		  const tLFea        *fea,
		  const unsigned int  c,
		  const unsigned int  q,
		  const int           t
		  );

void
tL_free_eprobst (
		 eprobst_t *eprobst
		 );

void
tL_reset_eprobst (
		  eprobst_t *eprobst
		  );

#define init_eprobst(EPROBST,AMODEL,FEA)				\
  init_calcelprob ( (EPROBST)->cep, (AMODEL),(FEA), 0, (FEA)->cols )

#endif /* __TL_PRV_EPROBST_H__ */
