/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  init_hmm.c - Implementació de 'init_hmm.h'.
 *
 *  Adrià Giménez Pastor, 2008,2009,2011,2012,2013.
 *
 */


#include <stddef.h>
#include <stdlib.h>

#define __TL_PRV
#include "iamcounts.h"
#include "init_hmm.h"
#include "init_state.h"




/**********************/
/* FUNCIONS PÚBLIQUES */
/**********************/

TL_API_FUNC(void)
tL_init_hmm_seg (
		 tLHMMInitializer *init,
		 tLAMiCounts      *counts,
		 const int         c,
		 const tLFea      *fea,
		 const int         begin,
		 const int         nframes
		 )
{
  
  tLFloat frac, accum;
  int i, next, prev;
  
  
  frac= ((tLFloat) nframes) / ((tLFloat) init->amodel->hmms[c].Q);
  accum= 0.0;
  prev= 0;
  for ( i= 0; i < init->amodel->hmms[c].Q; ++i )
    {
      accum+= frac;
      next= (int) (accum + 0.5);
      tL_init_state ( init, counts, c, i, fea, begin+prev, next - prev );
      prev= next;
    }
  
} /* end tL_init_hmm_seg */
