/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  init_proto.h - Funció que incrementa els comptadors d'un
 *                 prototip per a un 'frame' donat.
 *
 *  Adrià Giménez Pastor, 2008,2009,2011,2013.
 *
 */

#ifndef __TL_PRV_INIT_PROTO_H__
#define __TL_PRV_INIT_PROTO_H__

#include "init_hmm.h"

/* Es suposa que el FRAME ha passat el test global, i que es troba en
 * un vector de frames. BFRAME és el frame inicial. FRAME i BFRAME són
 * en realitat iteradors vàlids que apunten al frame i al primer frame
 * de l'imatge.
 */
#define init_proto(INIT,STATES,CSTATES,Q,FEA,T)			\
  (INIT)->meths->init ( INIT, (INIT)->amodel->global,		\
			STATES, CSTATES, Q, FEA, T )

#endif /* __TL_PRV_INIT_PROTO_H__ */
