/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  init_state.c - Implementació de 'init_state.h'.
 *
 *  Adrià Giménez Pastor, 2008,2009,2011,2013.
 *
 */


#define __TL_PRV
#include "error.h"
#include "iamcounts.h"
#include "init_proto.h"
#include "init_state.h"




/**********************/
/* FUNCIONS PÚBLIQUES */
/**********************/

void
tL_init_state (
	       tLHMMInitializer *init,
	       tLAMiCounts      *counts,
	       const int         c,
	       const int         q,
	       const tLFea      *fea,
	       const int         begin,
	       const int         nframes
	       )
{
  
  iamcount_hmm_t ccount;
  tLAModelHMM cchar;
  int i;
  
  
  cchar= init->amodel->hmms[c];
  ccount= counts->hmms[c];
  init_proto ( init, cchar.states, ccount.states, q, fea, begin );
  for ( i= 1; i < nframes; ++i )
    {
      init_proto ( init, cchar.states, ccount.states, q, fea, begin+i );
      ++(ccount.trans.lineal.p[q].p0);
    }
  ++(ccount.trans.lineal.p[q].p1);
  
} /* end tL_init_state */
