/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  lexicon.h - Definició del diccionari de paraules.
 *
 *  Adrià Giménez Pastor, 2008,2011,2012.
 *
 */

#ifndef __TL_PRV_LEXICON_H__
#define __TL_PRV_LEXICON_H__


#include <stddef.h>
#include <stdio.h>

#include "lexicon_public.h"
#include "common.h"
#include "text.h"


/* DEFINICIÓ */

#define NULL_ENTRY 0

struct _tLLexiconEntry
{
  
  tLSeq        *cs;      /* Seqüència codificada. */
  tLProb         p;       /* Probabilitat de que la paraula es
			     codifique així. */
  unsigned long  w;       /* Paraula associada a l'entrada. */
  size_t         next;    /* Següent entrada per a aquesta paraula. */
  
};

/* És un parell wildcard i caràcter pertanyent a eixe wildcard. */
struct _tLLexiconCWNode
{
  
  size_t wildcard;
  size_t sym;
  size_t next;        /* Següent node pertanyent a este wildcard. 0
			 indica NULL. */
  
};

/* Transició entre nodes de crosswords. */
struct _tLLexiconCWTrans
{
  
  size_t to;      /* Punter a cwnodes. */
  size_t next;    /* Punter al següent node o a 0 (NULL). */
  
};


/* FUNCIONS */

/* Afegeix una nova entrada. Torna
 * 1 si és la primera entrada per a eixa
 * paraula, 0 en cas contrari. La primera
 * paraula que s'inserte serà la 0,
 * la segëunt la 1, etc.
 */
/* PROBABLEMENT ESTÀ FUNCIÓ ACABE SIGUENT PÚBLICA. */
int
tL_lexicon_add (
		tLLexicon    *lexicon,
		const char   *word,
		const tLProb  p,
		const tLSeq *cs
		);

/* Ajusta la memòria del diccionari. */
/* PROBABLEMENT ESTÀ FUNCIÓ ACABE SIGUENT PÚBLICA. */
void
tL_lexicon_adjust (
		   tLLexicon *lexicon
		   );


#endif /* __TL_PRV_LEXICON_H__ */
