/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  mem.h - Macros per a reservar memòria.
 *
 *  Adrià Giménez Pastor, 2008,2011,2012.
 *
 */

#ifndef __TL_PRV_MEM_H__
#define __TL_PRV_MEM_H__

#include <stdlib.h>

void * tL_mem_alloc__ ( size_t nbytes );
void * tL_mem_realloc__ ( void * ptr, size_t nbytes );
void * tL_mem_calloc__ ( size_t nobjs, size_t size );

#define mem_alloc(type,size)				\
  ((type *) tL_mem_alloc__ ( sizeof(type) * (size) ))

#define mem_calloc(type,size)				\
  ((type *) tL_mem_calloc__ ( (size), sizeof(type) ))

#define mem_realloc(type,ptr,size)				\
  ((type *) tL_mem_realloc__ ( ptr, sizeof(type) * (size) ))

#endif /* __TL_PRV_MEM_H__ */
