/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  mllr_alg.h - Algorisme MLLR per a matrius completes partint de
 *                Gaussianes diagonals.
 *
 *  Miguel Ángel del Agua Teba.
 */

#ifndef __MLLR_ALG_FULL_H__
#define __MLLR_ALG_FULL_H__

#include "amcounts/dgaussian.h"
#include "amodel/dgaussian.h"
#include "cmllr_alg.h"
#include "common.h"

typedef struct {
  
  double       **G;
  double       **Z;
  int           *ipiv;
  double        *z;
  double       **Dmatrix;
  
} mllr_alg_data_t ;

void
tL_mllr_alg_data_alloc (
			mllr_alg_data_t *mem_vars,
			uint             D
			);

void
tL_mllr_alg_data_free (
			     mllr_alg_data_t *mem_vars
			     );

int
tL_mllr_alg (
	     const cmllr_alg_paramscounts_t    *pcs,
	     const dgaussian_global_t          *global,
	     double                           **W,
	     mllr_alg_data_t             *mem_vars,
	     char                             **err
	     );

#endif /* __MLLR_ALG_FULL_H__ */
