/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  bernoulli.h - Bernoulli.
 *
 *  Adrià Giménez Pastor, 2008,2009,2010,2011,2012.
 *
 */

#ifndef __TL_PRV_STATESTR__BERNOULLI_H__
#define __TL_PRV_STATESTR__BERNOULLI_H__

#include "../statestr.h"

/* Memòria auxiliar. */

/* Memòria auxiliar per a càlculs. */
typedef struct
{
  
  tLFloat      *calc1;
  tLFloat      *calc0;
  unsigned int  calc_size;
  
} Bernoulli_maux_t;

Bernoulli_maux_t *
tL_Bernoulli_maux_create (
			  const unsigned int size    /* Grandària inicial. */
			  );

void
tL_Bernoulli_maux_free (
			Bernoulli_maux_t *maux
			);


/* STRF */

str_factory_t *
tL_create_strf_bernoulli (
			  void *global
			  );


/* STRVF */

strv_factory_t *
tL_create_strvf_bernoulli (
			   void *global
			   );


/* Funcions Públiques. */

void
tL_Bernoulli_get_ready (
			statestr_t  *statestr,
			const tLFea *fea,
			void        *global
			);


#endif /* __TL_PRV_STATESTR__BERNOULLI_H__ */
