/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  text.h - Funcions bàsiques per a manipular text.
 *
 *  Adrià Giménez Pastor, 2008,2010,2011.
 *
 */


#ifndef __TL_PRV_TEXT_H__
#define __TL_PRV_TEXT_H__

#include "text_public.h"


/* TIPUS BUFFER */

/* Duplica la capacitat del buffer. */
void
tL_resize_buffer (
		  tLBuffer *buffer
		  );


/* TIPUS SEQÜÈNCIA CODIFICADA. */

void *
_tL_cscopy (
	    const void *s
	    );

#define cscopy(CSP)                        \
   ((tLSeq *) _tL_cscopy ( (void *) (CSP) ))


/* TIPUS DICCIONARIS */

/* Crea un diccionari de seqüències
   codificades. */
tLDict *
tL_dict_cseqs_new ();

/* Torna la seqüència codificada associada
   a l'identificador. */
#define dict_GCSEQ(DICT,ID)           \
   ((const tLSeq *) (DICT)->data[(ID)])


/* FUNCIONS */

/* Codifica un token en 'UTF-8' fent ús d'un vocabulari de
 * caràcters. Hi ha que passar la grandària de la memòria de la
 * seqüència. En cas d'error torna -1, i si err!= NULL es crea una
 * missatge d'error, 0 en cas contrari.
 */
int
tL_utf8tocseq (
	       const char    *token,
	       const tLDict  *syms,
	       tLSeq        *cs,
	       size_t        *cs_size,
	       char         **err
	       );

#endif /* __TL_PRV_TEXT_H__ */
