/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  wordraph.h - Graf de paraules.
 *
 *  Adrià Giménez Pastor, 2011,2012.
 *
 */

#ifndef __TL_PRV_WORDGRAPH_H__
#define __TL_PRV_WORDGRAPH_H__

#include "wordgraph_public.h"

/* FUNCIONS */

/* Afegeix sense reservar memòria. Torna l'aresta insertada. */
tLWGEdge *
tL_wordgraph_add_edge (
		       tLWordGraph         *wg,
		       const size_t         from,
		       const size_t         to,
		       const unsigned long  word
		       );

tLWordGraph *
tL_wordgraph_alloc (
		    const size_t NS,
		    const size_t NE,
		    const size_t NSG
		    );

void
tL_wordgraph_realloc (
		      tLWordGraph  *wg,
		      const size_t  NS,
		      const size_t  NE,
		      const size_t  NSG
		      );

#endif /* __TL_PRV_WORDGRAPH_H__ */
