/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  print_mixcounts.c - Implementació de 'print_mixcounts.h'.
 *
 *  Adrià Giménez Pastor, 2012,2013.
 *
 */


#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>

/* i18n includes and defines */
#include <locale.h>
#include "intl.h"

#include "print_mixcounts.h"




void
print_mixcounts (
		 const char     *fn,
		 const tLAModel *amodel,
		 const tLDict   *syms,
		 tLAMlogCounts  *logcounts,
		 tLAMiCounts    *icounts,
		 const tLBool    viterbi
		 )
{
  
  FILE *f;
  tLMixCounts *counts;
  char *err;
  
  
  f= fopen ( fn, "w" );
  if ( f == NULL )
    tL_error ( _("Could not open '%s' for writing"), fn );
  counts=
    viterbi ?
    tL_amicounts_get_mixcounts ( icounts, amodel, &err ) :
    tL_amlogcounts_get_mixcounts ( logcounts, amodel, &err );
  if ( counts == NULL ) tL_error ( err );
  tL_mixcounts_print ( counts, amodel, syms, f );
  tL_mixcounts_free ( counts, amodel );
  fclose ( f );
  
} /* end print_mixcounts */
