/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *  Copyright 2008,2009,2010,2011 Adrià Giménez Pastor and Alfons Juan Císcar
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  write_amodel.c - Implementació de 'write_amodel.h'.
 *
 *  Adrià Giménez Pastor, 2008,2011,2013.
 *
 */


#include <stddef.h>
#include <stdio.h>

/* i18n includes and defines */
#include <locale.h>
#include "intl.h"

#include "write_amodel.h"




void
write_amodel (
              const char     *fn,
              const tLAModel *amodel,
	      const tLDict   *syms,
	      const tLBool    binary
              )
{

  FILE *f;


  if ( fn != NULL )
    {
      f= fopen ( fn, binary?"wb":"w" );
      if ( f == NULL )
        tL_error ( _("Could not open file '%s'"), fn );
      tL_amodel_print ( amodel, f, syms, binary );
      fclose ( f );
    }
  else tL_amodel_print ( amodel, stdout, syms, binary );

} /* end write_amodel */
