/*
 *  Copyright 2012,2013,2014 transLectures-UPV Team
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
/*
 *  write_counts.c - Implementació de 'write_counts.h'.
 *
 *  Adrià Giménez Pastor, 2012,2013.
 *
 */


#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>

/* i18n includes and defines */
#include <locale.h>
#include "intl.h"

#include "write_counts.h"




void
write_counts (
	      const char          *output_fn,
	      const tLAModel      *amodel,
	      const tLAMlogCounts *logcounts,
	      const tLAMiCounts   *icounts,
	      const tLBool         binary,
	      const tLBool         viterbi
	      )
{
  
  FILE *f;
  
  
  f= output_fn==NULL ? stdout : fopen ( output_fn, "w" );
  if ( f == NULL ) tL_error ( _("Could not open '%s'"), output_fn );
  
  if ( viterbi ) tL_amicounts_print ( icounts, amodel, f, binary );
  else           tL_amlogcounts_print ( logcounts, amodel, f, binary );
  
  if ( f != stdout ) fclose ( f );
    
} /* end write_counts */
